import { FC } from "react";
import { BrowserNode } from "@connext/vector-sdk";
export declare type ConnextModalProps = {
    showModal: boolean;
    routerPublicIdentifier: string;
    depositChainId?: number;
    depositChainProvider: string;
    depositAssetId: string;
    withdrawChainProvider: string;
    withdrawChainId?: number;
    withdrawAssetId: string;
    withdrawalAddress: string;
    vaultName: string;
    withdrawalRecipient: string;
    transferAmount?: string;
    injectedProvider?: any;
    loginProvider?: any;
    iframeSrcOverride?: string;
    withdrawCallTo?: string;
    withdrawCallData?: string;
    onClose: () => void;
    onReady?: (params: {
        depositChannelAddress: string;
        withdrawChannelAddress: string;
    }) => any;
    onSwap?: (inputSenderAmountWei: string, node: BrowserNode) => Promise<void>;
    onDepositTxCreated?: (txHash: string) => void;
    onFinished?: (txHash: string, amountWei: string) => void;
    generateCallData?: (toWithdraw: string, toAssetId: string, node: BrowserNode) => Promise<{
        callData?: string;
    }>;
};
declare const ConnextModal: FC<ConnextModalProps>;
export default ConnextModal;
