'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var Modal = require('styled-react-modal');
var Modal__default = _interopDefault(Modal);
var vectorSdk = require('@connext/vector-sdk');
var units = require('@ethersproject/units');
var bignumber = require('@ethersproject/bignumber');
var address = require('@ethersproject/address');
var providers = require('@ethersproject/providers');
var riveJs = require('rive-js');
var constants = require('@ethersproject/constants');
var vectorTypes = require('@connext/vector-types');
var QRCode = _interopDefault(require('qrcode.react'));
var Select = _interopDefault(require('react-select'));

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _taggedTemplateLiteralLoose(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  strings.raw = raw;
  return strings;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var runtime_1 = /*#__PURE__*/createCommonjsModule(function (module) {
  /**
   * Copyright (c) 2014-present, Facebook, Inc.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */
  var runtime = function (exports) {

    var Op = Object.prototype;
    var hasOwn = Op.hasOwnProperty;
    var undefined$1; // More compressible than void 0.

    var $Symbol = typeof Symbol === "function" ? Symbol : {};
    var iteratorSymbol = $Symbol.iterator || "@@iterator";
    var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
    var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

    function define(obj, key, value) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
      return obj[key];
    }

    try {
      // IE 8 has a broken Object.defineProperty that only works on DOM objects.
      define({}, "");
    } catch (err) {
      define = function define(obj, key, value) {
        return obj[key] = value;
      };
    }

    function wrap(innerFn, outerFn, self, tryLocsList) {
      // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
      var generator = Object.create(protoGenerator.prototype);
      var context = new Context(tryLocsList || []); // The ._invoke method unifies the implementations of the .next,
      // .throw, and .return methods.

      generator._invoke = makeInvokeMethod(innerFn, self, context);
      return generator;
    }

    exports.wrap = wrap; // Try/catch helper to minimize deoptimizations. Returns a completion
    // record like context.tryEntries[i].completion. This interface could
    // have been (and was previously) designed to take a closure to be
    // invoked without arguments, but in all the cases we care about we
    // already have an existing method we want to call, so there's no need
    // to create a new function object. We can even get away with assuming
    // the method takes exactly one argument, since that happens to be true
    // in every case, so we don't have to touch the arguments object. The
    // only additional allocation required is the completion record, which
    // has a stable shape and so hopefully should be cheap to allocate.

    function tryCatch(fn, obj, arg) {
      try {
        return {
          type: "normal",
          arg: fn.call(obj, arg)
        };
      } catch (err) {
        return {
          type: "throw",
          arg: err
        };
      }
    }

    var GenStateSuspendedStart = "suspendedStart";
    var GenStateSuspendedYield = "suspendedYield";
    var GenStateExecuting = "executing";
    var GenStateCompleted = "completed"; // Returning this object from the innerFn has the same effect as
    // breaking out of the dispatch switch statement.

    var ContinueSentinel = {}; // Dummy constructor functions that we use as the .constructor and
    // .constructor.prototype properties for functions that return Generator
    // objects. For full spec compliance, you may wish to configure your
    // minifier not to mangle the names of these two functions.

    function Generator() {}

    function GeneratorFunction() {}

    function GeneratorFunctionPrototype() {} // This is a polyfill for %IteratorPrototype% for environments that
    // don't natively support it.


    var IteratorPrototype = {};

    IteratorPrototype[iteratorSymbol] = function () {
      return this;
    };

    var getProto = Object.getPrototypeOf;
    var NativeIteratorPrototype = getProto && getProto(getProto(values([])));

    if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
      // This environment has a native %IteratorPrototype%; use it instead
      // of the polyfill.
      IteratorPrototype = NativeIteratorPrototype;
    }

    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
    GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
    GeneratorFunctionPrototype.constructor = GeneratorFunction;
    GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"); // Helper for defining the .next, .throw, and .return methods of the
    // Iterator interface in terms of a single ._invoke method.

    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function (method) {
        define(prototype, method, function (arg) {
          return this._invoke(method, arg);
        });
      });
    }

    exports.isGeneratorFunction = function (genFun) {
      var ctor = typeof genFun === "function" && genFun.constructor;
      return ctor ? ctor === GeneratorFunction || // For the native GeneratorFunction constructor, the best we can
      // do is to check its .name property.
      (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
    };

    exports.mark = function (genFun) {
      if (Object.setPrototypeOf) {
        Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
      } else {
        genFun.__proto__ = GeneratorFunctionPrototype;
        define(genFun, toStringTagSymbol, "GeneratorFunction");
      }

      genFun.prototype = Object.create(Gp);
      return genFun;
    }; // Within the body of any async function, `await x` is transformed to
    // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
    // `hasOwn.call(value, "__await")` to determine if the yielded value is
    // meant to be awaited.


    exports.awrap = function (arg) {
      return {
        __await: arg
      };
    };

    function AsyncIterator(generator, PromiseImpl) {
      function invoke(method, arg, resolve, reject) {
        var record = tryCatch(generator[method], generator, arg);

        if (record.type === "throw") {
          reject(record.arg);
        } else {
          var result = record.arg;
          var value = result.value;

          if (value && typeof value === "object" && hasOwn.call(value, "__await")) {
            return PromiseImpl.resolve(value.__await).then(function (value) {
              invoke("next", value, resolve, reject);
            }, function (err) {
              invoke("throw", err, resolve, reject);
            });
          }

          return PromiseImpl.resolve(value).then(function (unwrapped) {
            // When a yielded Promise is resolved, its final value becomes
            // the .value of the Promise<{value,done}> result for the
            // current iteration.
            result.value = unwrapped;
            resolve(result);
          }, function (error) {
            // If a rejected Promise was yielded, throw the rejection back
            // into the async generator function so it can be handled there.
            return invoke("throw", error, resolve, reject);
          });
        }
      }

      var previousPromise;

      function enqueue(method, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function (resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }

        return previousPromise = // If enqueue has been called before, then we want to wait until
        // all previous Promises have been resolved before calling invoke,
        // so that results are always delivered in the correct order. If
        // enqueue has not been called before, then it is important to
        // call invoke immediately, without waiting on a callback to fire,
        // so that the async generator function has the opportunity to do
        // any necessary setup in a predictable way. This predictability
        // is why the Promise constructor synchronously invokes its
        // executor callback, and why async functions synchronously
        // execute code before the first await. Since we implement simple
        // async functions in terms of async generators, it is especially
        // important to get this right, even though it requires care.
        previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, // Avoid propagating failures to Promises returned by later
        // invocations of the iterator.
        callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      } // Define the unified helper method that is used to implement .next,
      // .throw, and .return (see defineIteratorMethods).


      this._invoke = enqueue;
    }

    defineIteratorMethods(AsyncIterator.prototype);

    AsyncIterator.prototype[asyncIteratorSymbol] = function () {
      return this;
    };

    exports.AsyncIterator = AsyncIterator; // Note that simple async functions are implemented on top of
    // AsyncIterator objects; they just return a Promise for the value of
    // the final result produced by the iterator.

    exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
      if (PromiseImpl === void 0) PromiseImpl = Promise;
      var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
      return exports.isGeneratorFunction(outerFn) ? iter // If outerFn is a generator, return the full iterator.
      : iter.next().then(function (result) {
        return result.done ? result.value : iter.next();
      });
    };

    function makeInvokeMethod(innerFn, self, context) {
      var state = GenStateSuspendedStart;
      return function invoke(method, arg) {
        if (state === GenStateExecuting) {
          throw new Error("Generator is already running");
        }

        if (state === GenStateCompleted) {
          if (method === "throw") {
            throw arg;
          } // Be forgiving, per 25.3.3.3.3 of the spec:
          // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume


          return doneResult();
        }

        context.method = method;
        context.arg = arg;

        while (true) {
          var delegate = context.delegate;

          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);

            if (delegateResult) {
              if (delegateResult === ContinueSentinel) continue;
              return delegateResult;
            }
          }

          if (context.method === "next") {
            // Setting context._sent for legacy support of Babel's
            // function.sent implementation.
            context.sent = context._sent = context.arg;
          } else if (context.method === "throw") {
            if (state === GenStateSuspendedStart) {
              state = GenStateCompleted;
              throw context.arg;
            }

            context.dispatchException(context.arg);
          } else if (context.method === "return") {
            context.abrupt("return", context.arg);
          }

          state = GenStateExecuting;
          var record = tryCatch(innerFn, self, context);

          if (record.type === "normal") {
            // If an exception is thrown from innerFn, we leave state ===
            // GenStateExecuting and loop back for another invocation.
            state = context.done ? GenStateCompleted : GenStateSuspendedYield;

            if (record.arg === ContinueSentinel) {
              continue;
            }

            return {
              value: record.arg,
              done: context.done
            };
          } else if (record.type === "throw") {
            state = GenStateCompleted; // Dispatch the exception by looping back around to the
            // context.dispatchException(context.arg) call above.

            context.method = "throw";
            context.arg = record.arg;
          }
        }
      };
    } // Call delegate.iterator[context.method](context.arg) and handle the
    // result, either by returning a { value, done } result from the
    // delegate iterator, or by modifying context.method and context.arg,
    // setting context.delegate to null, and returning the ContinueSentinel.


    function maybeInvokeDelegate(delegate, context) {
      var method = delegate.iterator[context.method];

      if (method === undefined$1) {
        // A .throw or .return when the delegate iterator has no .throw
        // method always terminates the yield* loop.
        context.delegate = null;

        if (context.method === "throw") {
          // Note: ["return"] must be used for ES3 parsing compatibility.
          if (delegate.iterator["return"]) {
            // If the delegate iterator has a return method, give it a
            // chance to clean up.
            context.method = "return";
            context.arg = undefined$1;
            maybeInvokeDelegate(delegate, context);

            if (context.method === "throw") {
              // If maybeInvokeDelegate(context) changed context.method from
              // "return" to "throw", let that override the TypeError below.
              return ContinueSentinel;
            }
          }

          context.method = "throw";
          context.arg = new TypeError("The iterator does not provide a 'throw' method");
        }

        return ContinueSentinel;
      }

      var record = tryCatch(method, delegate.iterator, context.arg);

      if (record.type === "throw") {
        context.method = "throw";
        context.arg = record.arg;
        context.delegate = null;
        return ContinueSentinel;
      }

      var info = record.arg;

      if (!info) {
        context.method = "throw";
        context.arg = new TypeError("iterator result is not an object");
        context.delegate = null;
        return ContinueSentinel;
      }

      if (info.done) {
        // Assign the result of the finished delegate to the temporary
        // variable specified by delegate.resultName (see delegateYield).
        context[delegate.resultName] = info.value; // Resume execution at the desired location (see delegateYield).

        context.next = delegate.nextLoc; // If context.method was "throw" but the delegate handled the
        // exception, let the outer generator proceed normally. If
        // context.method was "next", forget context.arg since it has been
        // "consumed" by the delegate iterator. If context.method was
        // "return", allow the original .return call to continue in the
        // outer generator.

        if (context.method !== "return") {
          context.method = "next";
          context.arg = undefined$1;
        }
      } else {
        // Re-yield the result returned by the delegate method.
        return info;
      } // The delegate iterator is finished, so forget it and continue with
      // the outer generator.


      context.delegate = null;
      return ContinueSentinel;
    } // Define Generator.prototype.{next,throw,return} in terms of the
    // unified ._invoke helper method.


    defineIteratorMethods(Gp);
    define(Gp, toStringTagSymbol, "Generator"); // A Generator should always return itself as the iterator object when the
    // @@iterator function is called on it. Some browsers' implementations of the
    // iterator prototype chain incorrectly implement this, causing the Generator
    // object to not be returned from this call. This ensures that doesn't happen.
    // See https://github.com/facebook/regenerator/issues/274 for more details.

    Gp[iteratorSymbol] = function () {
      return this;
    };

    Gp.toString = function () {
      return "[object Generator]";
    };

    function pushTryEntry(locs) {
      var entry = {
        tryLoc: locs[0]
      };

      if (1 in locs) {
        entry.catchLoc = locs[1];
      }

      if (2 in locs) {
        entry.finallyLoc = locs[2];
        entry.afterLoc = locs[3];
      }

      this.tryEntries.push(entry);
    }

    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal";
      delete record.arg;
      entry.completion = record;
    }

    function Context(tryLocsList) {
      // The root entry object (effectively a try statement without a catch
      // or a finally block) gives us a place to store values thrown from
      // locations where there is no enclosing try statement.
      this.tryEntries = [{
        tryLoc: "root"
      }];
      tryLocsList.forEach(pushTryEntry, this);
      this.reset(true);
    }

    exports.keys = function (object) {
      var keys = [];

      for (var key in object) {
        keys.push(key);
      }

      keys.reverse(); // Rather than returning an object with a next method, we keep
      // things simple and return the next function itself.

      return function next() {
        while (keys.length) {
          var key = keys.pop();

          if (key in object) {
            next.value = key;
            next.done = false;
            return next;
          }
        } // To avoid creating an additional object, we just hang the .value
        // and .done properties off the next function object itself. This
        // also ensures that the minifier will not anonymize the function.


        next.done = true;
        return next;
      };
    };

    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];

        if (iteratorMethod) {
          return iteratorMethod.call(iterable);
        }

        if (typeof iterable.next === "function") {
          return iterable;
        }

        if (!isNaN(iterable.length)) {
          var i = -1,
              next = function next() {
            while (++i < iterable.length) {
              if (hasOwn.call(iterable, i)) {
                next.value = iterable[i];
                next.done = false;
                return next;
              }
            }

            next.value = undefined$1;
            next.done = true;
            return next;
          };

          return next.next = next;
        }
      } // Return an iterator with no values.


      return {
        next: doneResult
      };
    }

    exports.values = values;

    function doneResult() {
      return {
        value: undefined$1,
        done: true
      };
    }

    Context.prototype = {
      constructor: Context,
      reset: function reset(skipTempReset) {
        this.prev = 0;
        this.next = 0; // Resetting context._sent for legacy support of Babel's
        // function.sent implementation.

        this.sent = this._sent = undefined$1;
        this.done = false;
        this.delegate = null;
        this.method = "next";
        this.arg = undefined$1;
        this.tryEntries.forEach(resetTryEntry);

        if (!skipTempReset) {
          for (var name in this) {
            // Not sure about the optimal order of these conditions:
            if (name.charAt(0) === "t" && hasOwn.call(this, name) && !isNaN(+name.slice(1))) {
              this[name] = undefined$1;
            }
          }
        }
      },
      stop: function stop() {
        this.done = true;
        var rootEntry = this.tryEntries[0];
        var rootRecord = rootEntry.completion;

        if (rootRecord.type === "throw") {
          throw rootRecord.arg;
        }

        return this.rval;
      },
      dispatchException: function dispatchException(exception) {
        if (this.done) {
          throw exception;
        }

        var context = this;

        function handle(loc, caught) {
          record.type = "throw";
          record.arg = exception;
          context.next = loc;

          if (caught) {
            // If the dispatched exception was caught by a catch block,
            // then let that catch block handle the exception normally.
            context.method = "next";
            context.arg = undefined$1;
          }

          return !!caught;
        }

        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          var record = entry.completion;

          if (entry.tryLoc === "root") {
            // Exception thrown outside of any try block that could handle
            // it, so set the completion value of the entire function to
            // throw the exception.
            return handle("end");
          }

          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn.call(entry, "catchLoc");
            var hasFinally = hasOwn.call(entry, "finallyLoc");

            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              } else if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }
            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              }
            } else if (hasFinally) {
              if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }
            } else {
              throw new Error("try statement without catch or finally");
            }
          }
        }
      },
      abrupt: function abrupt(type, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }

        if (finallyEntry && (type === "break" || type === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
          // Ignore the finally entry if control is not jumping to a
          // location outside the try/catch block.
          finallyEntry = null;
        }

        var record = finallyEntry ? finallyEntry.completion : {};
        record.type = type;
        record.arg = arg;

        if (finallyEntry) {
          this.method = "next";
          this.next = finallyEntry.finallyLoc;
          return ContinueSentinel;
        }

        return this.complete(record);
      },
      complete: function complete(record, afterLoc) {
        if (record.type === "throw") {
          throw record.arg;
        }

        if (record.type === "break" || record.type === "continue") {
          this.next = record.arg;
        } else if (record.type === "return") {
          this.rval = this.arg = record.arg;
          this.method = "return";
          this.next = "end";
        } else if (record.type === "normal" && afterLoc) {
          this.next = afterLoc;
        }

        return ContinueSentinel;
      },
      finish: function finish(finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.finallyLoc === finallyLoc) {
            this.complete(entry.completion, entry.afterLoc);
            resetTryEntry(entry);
            return ContinueSentinel;
          }
        }
      },
      "catch": function _catch(tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;

            if (record.type === "throw") {
              var thrown = record.arg;
              resetTryEntry(entry);
            }

            return thrown;
          }
        } // The context.catch method must only be called with a location
        // argument that corresponds to a known catch block.


        throw new Error("illegal catch attempt");
      },
      delegateYield: function delegateYield(iterable, resultName, nextLoc) {
        this.delegate = {
          iterator: values(iterable),
          resultName: resultName,
          nextLoc: nextLoc
        };

        if (this.method === "next") {
          // Deliberately forget the last sent value so that we don't
          // accidentally pass it on to the delegate.
          this.arg = undefined$1;
        }

        return ContinueSentinel;
      }
    }; // Regardless of whether this script is executing as a CommonJS module
    // or not, return the runtime object so that we can declare the variable
    // regeneratorRuntime in the outer scope, which allows this module to be
    // injected easily by `bin/regenerator --include-runtime script.js`.

    return exports;
  }( // If this script is executing as a CommonJS module, use module.exports
  // as the regeneratorRuntime namespace. Otherwise create a new empty
  // object. Either way, the resulting object will be used to initialize
  // the regeneratorRuntime variable at the top of this file.
   module.exports );

  try {
    regeneratorRuntime = runtime;
  } catch (accidentalStrictMode) {
    // This module should not be running in strict mode, so the above
    // assignment should always work unless something is misconfigured. Just
    // in case runtime.js accidentally runs in strict mode, we can escape
    // strict mode using a global Function call. This could conceivably fail
    // if a Content Security Policy forbids using Function, but in that case
    // the proper solution is to fix the accidental strict mode problem. If
    // you've misconfigured your bundler to force strict mode and applied a
    // CSP to forbid Function, and you're not willing to fix either of those
    // problems, please detail your unique predicament in a GitHub issue.
    Function("r", "regeneratorRuntime = r")(runtime);
  }
});

var ERROR_STATES = {
  ERROR_SETUP: "ERROR_SETUP",
  ERROR_TRANSFER: "ERROR_TRANSFER",
  ERROR_NETWORK: "ERROR_NETWORK",
  ERROR_RECOVER: "ERROR_RECOVER"
};
var SCREEN_STATES = /*#__PURE__*/_extends({
  LOADING: "LOADING",
  USER_INFO: "USER_INFO",
  EXISTING_BALANCE: "EXISTING_BALANCE",
  HISTORY: "HISTORY",
  SWAP: "SWAP",
  RECOVER: "RECOVER",
  RECOVER_SUCCESS: "RECOVER_SUCCESS",
  LISTENER: "LISTENER",
  STATUS: "STATUS",
  SUCCESS: "SUCCESS"
}, ERROR_STATES);

var _templateObject;
var Box = /*#__PURE__*/styled__default.div(_templateObject || (_templateObject = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  &&& {\n    border-width: 0px;\n    border-style: solid;\n    box-sizing: border-box;\n    background-color: ", ";\n    border-radius: ", ";\n  }\n"])), function (props) {
  return props.colorScheme;
}, function (props) {
  return props.borderRadius;
});

var _templateObject$1;

var Spinner = function Spinner() {
  return React__default.createElement(StyledSpinner, {
    viewBox: "0 0 50 50"
  }, React__default.createElement("circle", {
    className: "path",
    cx: "25",
    cy: "25",
    r: "20",
    fill: "none",
    strokeWidth: "4"
  }));
};

var StyledSpinner = /*#__PURE__*/styled__default.svg(_templateObject$1 || (_templateObject$1 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  animation: rotate 2s linear infinite;\n  width: 2.5rem;\n\n  & .path {\n    stroke: #26b1d6;\n    stroke-linecap: round;\n    animation: dash 1.5s ease-in-out infinite;\n  }\n\n  @keyframes rotate {\n    100% {\n      transform: rotate(360deg);\n    }\n  }\n  @keyframes dash {\n    0% {\n      stroke-dasharray: 1, 150;\n      stroke-dashoffset: 0;\n    }\n    50% {\n      stroke-dasharray: 90, 150;\n      stroke-dashoffset: -35;\n    }\n    100% {\n      stroke-dasharray: 90, 150;\n      stroke-dashoffset: -124;\n    }\n  }\n"])));

var _templateObject$2;
var Button = /*#__PURE__*/styled__default.button(_templateObject$2 || (_templateObject$2 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  &&& {\n    height: ", ";\n    min-width: ", ";\n    font-size: ", ";\n    padding-left: ", ";\n    padding-right: ", ";\n    border: ", ";\n    border-style: ", ";\n    border-radius: ", ";\n    background-color: ", ";\n    color: ", ";\n    text-transform: ", ";\n    margin-right: ", ";\n    font-weight: 400;\n    font-style: normal;\n    font-family: Roboto;\n    box-sizing: border-box;\n    display: inline-flex;\n    appearance: none;\n    align-items: center;\n    justify-content: center;\n    transition: all 250ms ease 0s;\n    user-select: none;\n    position: relative;\n    white-space: nowrap;\n    vertical-align: middle;\n    outline: none;\n    width: auto;\n    line-height: 1.2;\n\n    overflow: visible;\n    box-shadow: none !important;\n    cursor: pointer;\n    line-height: inherit;\n\n    &:hover {\n      opacity: 1;\n      filter: brightness(150%);\n    }\n\n    :disabled {\n      opacity: 0.4;\n      cursor: not-allowed;\n    }\n  }\n"])), function (props) {
  var _props$size;

  return props.height || props.theme.space[props.theme.sizes[(_props$size = props.size) != null ? _props$size : "md"].h];
}, function (props) {
  var _props$size2;

  return props.theme.space[props.theme.sizes[(_props$size2 = props.size) != null ? _props$size2 : "md"].minW];
}, function (props) {
  var _props$size3;

  return props.theme.fontSizes[props.theme.sizes[(_props$size3 = props.size) != null ? _props$size3 : "md"].fontSize];
}, function (props) {
  var _props$size4;

  return props.theme.space[props.theme.sizes[(_props$size4 = props.size) != null ? _props$size4 : "md"].px];
}, function (props) {
  var _props$size5;

  return props.theme.space[props.theme.sizes[(_props$size5 = props.size) != null ? _props$size5 : "md"].px];
}, function (props) {
  return props.border || "1.5px #7b7b7b";
}, function (props) {
  return props.borderStyle || "solid";
}, function (props) {
  return props.borderRadius || "15px";
}, function (props) {
  return props.colorScheme || "white";
}, function (props) {
  return props.color || "inherit";
}, function (props) {
  return props.casing || "capitalize";
}, function (props) {
  return props.marginRight || "0px";
});

var _templateObject$3;
var Fonts = /*#__PURE__*/styled.createGlobalStyle(_templateObject$3 || (_templateObject$3 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n      /* latin-ext */\n      @font-face {\n        font-family: 'Cooper Hewitt';\n        font-style: normal;\n        font-weight: 700;\n        src: url(https://cdn.connext.network/fonts/cooper-hewitt/CooperHewitt-Semibold.otf);\n      }\n      /* latin-ext */\n      @font-face {\n        font-family: 'Cooper Hewitt';\n        font-style: normal;\n        font-weight: 500;\n        src: url(https://cdn.connext.network/fonts/cooper-hewitt/CooperHewitt-Medium.otf);\n      }\n      /* latin-ext */\n      @font-face {\n        font-family: 'Cooper Hewitt';\n        font-style: normal;\n        font-weight: 400;\n        src: url(https://cdn.connext.network/fonts/cooper-hewitt/CooperHewitt-Book.otf);\n      }\n      /* latin-ext */\n      @font-face {\n        font-family: 'Roboto';\n        font-style: normal;\n        font-weight: 700;\n        src: url(https://cdn.connext.network/fonts/roboto/Roboto-Bold.ttf);\n      }\n      /* latin-ext */\n      @font-face {\n        font-family: 'Roboto';\n        font-style: normal;\n        font-weight: 500;\n        src: url(https://cdn.connext.network/fonts/roboto/Roboto-Medium.ttf);\n      }\n      /* latin-ext */\n      @font-face {\n        font-family: 'Roboto';\n        font-style: normal;\n        font-weight: 400;\n        src: url(https://cdn.connext.network/fonts/roboto/Roboto-Regular.ttf);\n      }\n\n      /* latin-ext */\n      @font-face {\n        font-family: 'Roboto Mono';\n        font-style: normal;\n        font-weight: 400;\n        src: url(https://cdn.connext.network/fonts/roboto_mono/RobotoMono-Regular.ttf);\n      }\n      "])));

var _templateObject$4, _templateObject2, _templateObject3;
var IconBox = /*#__PURE__*/styled__default.div(_templateObject$4 || (_templateObject$4 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  border-width: 0px;\n  border-style: solid;\n  box-sizing: border-box;\n  width: ", ";\n  line-height: 1em;\n  flex-shrink: 0;\n  color: currentcolor;\n  vertical-align: middle;\n  display: block;\n"])), function (props) {
  return props.width || "1.125rem";
});
var WarningIcon = function WarningIcon() {
  return React__default.createElement("svg", {
    viewBox: "0 0 24 24",
    focusable: "false"
  }, React__default.createElement("path", {
    fill: "currentColor",
    d: "M23.119,20,13.772,2.15h0a2,2,0,0,0-3.543,0L.881,20a2,2,0,0,0,1.772,2.928H21.347A2,2,0,0,0,23.119,20ZM11,8.423a1,1,0,0,1,2,0v6a1,1,0,1,1-2,0Zm1.05,11.51h-.028a1.528,1.528,0,0,1-1.522-1.47,1.476,1.476,0,0,1,1.448-1.53h.028A1.527,1.527,0,0,1,13.5,18.4,1.475,1.475,0,0,1,12.05,19.933Z"
  }));
};
var CopyIcon = function CopyIcon() {
  return React__default.createElement("svg", {
    viewBox: "0 0 24 24",
    focusable: "false"
  }, React__default.createElement("path", {
    fill: "currentColor",
    d: "M16 1H4c-1.1 0-2 .9-2 2v14h2V3h12V1zm3 4H8c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h11c1.1 0 2-.9 2-2V7c0-1.1-.9-2-2-2zm0 16H8V7h11v14z"
  }));
};
var CheckCircleIcon = function CheckCircleIcon() {
  return React__default.createElement("svg", {
    viewBox: "0 0 24 24",
    focusable: "false"
  }, React__default.createElement("path", {
    fill: "currentColor",
    d: "M12,0A12,12,0,1,0,24,12,12.014,12.014,0,0,0,12,0Zm6.927,8.2-6.845,9.289a1.011,1.011,0,0,1-1.43.188L5.764,13.769a1,1,0,1,1,1.25-1.562l4.076,3.261,6.227-8.451A1,1,0,1,1,18.927,8.2Z"
  }));
};
var IconButton = /*#__PURE__*/styled__default.button(_templateObject2 || (_templateObject2 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  -webkit-font-smoothing: antialiased;\n  --removed-body-scroll-bar-size: 0px;\n  display: inline-flex;\n  appearance: none;\n  align-items: center;\n  justify-content: center;\n  transition: all 250ms ease 0s;\n  user-select: none;\n  position: relative;\n  white-space: nowrap;\n  vertical-align: middle;\n  outline: none;\n  width: auto;\n  border-radius: 0.375rem;\n  font-weight: 400;\n  font-style: normal;\n  font-family: Roboto;\n  text-transform: capitalize;\n  height: 2.5rem;\n  min-width: 2.5rem;\n  font-size: 16px;\n  padding: 0px;\n  border: 0px rgb(123, 123, 123);\n  box-sizing: border-box;\n  background: ", ";\n  overflow: visible;\n  box-shadow: none !important;\n  cursor: pointer;\n  line-height: inherit;\n  color: inherit;\n  cursor: ", ";\n  opacity: ", ";\n\n  &:hover {\n    ", "\n  }\n"])), function (props) {
  return props.isSelected ? "rgb(226, 232, 240)" : "transparent";
}, function (props) {
  return !props.isDisabled ? "pointer" : "not-allowed";
}, function (props) {
  return !props.isDisabled ? "1.0" : "0.4";
}, function (props) {
  return !props.isSelected && !props.isDisabled ? "background: rgb(237, 242, 247)" : "";
});
var IconContainer = /*#__PURE__*/styled__default.div(_templateObject3 || (_templateObject3 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  -webkit-font-smoothing: antialiased;\n  --removed-body-scroll-bar-size: 0px;\n  user-select: none;\n  white-space: nowrap;\n  font-weight: 400;\n  font-style: normal;\n  font-family: Roboto;\n  text-transform: capitalize;\n  font-size: ", ";\n  border-width: 0px;\n  border-style: solid;\n  box-sizing: border-box;\n  width: 24px;\n  height: 24px;\n  line-height: 1em;\n  flex-shrink: 0;\n  color: currentcolor;\n  vertical-align: middle;\n  display: block;\n"])), function (props) {
  return props.fontSize || "1rem";
});
var CloseButton = function CloseButton(_ref) {
  var onClick = _ref.onClick,
      isSelected = _ref.isSelected,
      isDisabled = _ref.isDisabled;
  return React__default.createElement(IconButton, {
    onClick: !isDisabled ? onClick : function () {},
    isSelected: isSelected,
    isDisabled: isDisabled
  }, React__default.createElement(IconContainer, null, React__default.createElement("svg", {
    viewBox: "0 0 24 24",
    focusable: "false",
    "aria-hidden": "true"
  }, React__default.createElement("path", {
    fill: "currentColor",
    d: "M.439,21.44a1.5,1.5,0,0,0,2.122,2.121L11.823,14.3a.25.25,0,0,1,.354,0l9.262,9.263a1.5,1.5,0,1,0,2.122-2.121L14.3,12.177a.25.25,0,0,1,0-.354l9.263-9.262A1.5,1.5,0,0,0,21.439.44L12.177,9.7a.25.25,0,0,1-.354,0L2.561.44A1.5,1.5,0,0,0,.439,2.561L9.7,11.823a.25.25,0,0,1,0,.354Z"
  }))));
};
var BackButton = function BackButton(_ref2) {
  var onClick = _ref2.onClick,
      isSelected = _ref2.isSelected,
      isDisabled = _ref2.isDisabled;
  return React__default.createElement(IconButton, {
    onClick: !isDisabled ? onClick : function () {},
    isSelected: isSelected,
    isDisabled: isDisabled
  }, React__default.createElement(IconContainer, null, React__default.createElement("svg", {
    viewBox: "0 0 24 24",
    focusable: "false",
    "aria-hidden": "true"
  }, React__default.createElement("path", {
    fill: "currentColor",
    d: "M20 11H7.83l5.59-5.59L12 4l-8 8 8 8 1.41-1.41L7.83 13H20v-2z"
  }))));
}; /// ** MENU:

var MenuButton = function MenuButton(_ref3) {
  var onClick = _ref3.onClick,
      isSelected = _ref3.isSelected;
  return React__default.createElement(IconButton, {
    onClick: onClick,
    isSelected: isSelected,
    isDisabled: false
  }, React__default.createElement(IconContainer, null, React__default.createElement("svg", {
    viewBox: "0 0 24 24",
    focusable: "false",
    "aria-hidden": "true"
  }, React__default.createElement("path", {
    fill: "currentColor",
    d: "M 3 5 A 1.0001 1.0001 0 1 0 3 7 L 21 7 A 1.0001 1.0001 0 1 0 21 5 L 3 5 z M 3 11 A 1.0001 1.0001 0 1 0 3 13 L 21 13 A 1.0001 1.0001 0 1 0 21 11 L 3 11 z M 3 17 A 1.0001 1.0001 0 1 0 3 19 L 21 19 A 1.0001 1.0001 0 1 0 21 17 L 3 17 z"
  }))));
};

var _templateObject$5, _templateObject2$1;
var InputGroup = /*#__PURE__*/styled__default(Box)(_templateObject$5 || (_templateObject$5 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  &&& {\n    width: 100%;\n    display: flex;\n    font-family: \"Roboto Mono\";\n    font-style: normal;\n    font-weight: 500;\n    line-height: 20px;\n    background-color: ", ";\n    border-radius: ", ";\n    flex: ", ";\n    align-items: center;\n  }\n"])), function (props) {
  return props.colorScheme || "#dedede";
}, function (props) {
  return props.borderRadius || "5px";
}, function (props) {
  return props.flex;
});
var Input = /*#__PURE__*/styled__default.input(_templateObject2$1 || (_templateObject2$1 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  &&& {\n    height: ", ";\n    font-size: ", ";\n    padding-left: ", ";\n    padding-right: ", ";\n    flex: ", ";\n    width: 100%;\n    min-width: 0px;\n    outline: 0px;\n    position: relative;\n    appearance: none;\n    transition: all 0.2s ease 0s;\n    font-family: inherit;\n    font-weight: inherit;\n    font-style: inherit;\n    line-height: inherit;\n    box-shadow: none;\n    border-radius: inherit;\n    border-width: 0px;\n    border-style: initial;\n    border-image: initial;\n    border-color: inherit;\n    background: inherit;\n    -webkit-appearance: textfield;\n\n    ::-webkit-search-decoration {\n      -webkit-appearance: none;\n    }\n    [type=\"number\"] {\n      -moz-appearance: textfield;\n    }\n    ::-webkit-outer-spin-button,\n    ::-webkit-inner-spin-button {\n      -webkit-appearance: none;\n    }\n  }\n"])), function (props) {
  var _props$body;

  return props.height || props.theme.space[props.theme.sizes[(_props$body = props.body) != null ? _props$body : "md"].h];
}, function (props) {
  var _props$body2;

  return props.fontSize || props.theme.fontSizes[props.theme.sizes[(_props$body2 = props.body) != null ? _props$body2 : "md"].fontSize];
}, function (props) {
  var _props$body3;

  return props.paddingLeft || props.theme.space[props.theme.sizes[(_props$body3 = props.body) != null ? _props$body3 : "md"].px];
}, function (props) {
  var _props$body4;

  return props.paddingRight || props.theme.space[props.theme.sizes[(_props$body4 = props.body) != null ? _props$body4 : "md"].px];
}, function (props) {
  return props.flex;
});

var _templateObject$6;
var Link = /*#__PURE__*/styled__default.a(_templateObject$6 || (_templateObject$6 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  &&& {\n    text-decoration: auto;\n    color: ", ";\n  }\n"])), function (props) {
  return props.color;
});

var _templateObject$7, _templateObject2$2, _templateObject3$1;
var MenuListPositioner = /*#__PURE__*/styled__default.div(_templateObject$7 || (_templateObject$7 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  -webkit-font-smoothing: antialiased;\n  --removed-body-scroll-bar-size: 0px;\n  color: inherit;\n  font-size: 1.25rem;\n  font-weight: 600;\n  border-width: 0px;\n  border-style: solid;\n  box-sizing: border-box;\n  z-index: 1;\n  position: absolute;\n  inset: 0px auto auto 0px;\n  visibility: ", ";\n  transform: ", ";\n"])), function (props) {
  return props.hidden ? "hidden" : "visible";
}, function (props) {
  return props.placement === "bottom-start" ? "translate3d(372px, 72px, 0px)" : "translate3d(188px, 72px, 0px)";
});
var MenuListContainer = /*#__PURE__*/styled__default.div(_templateObject2$2 || (_templateObject2$2 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  font-family: -apple-system, BlinkMacSystemFont, \"Segoe UI\", \"Roboto\", \"Oxygen\", \"Ubuntu\", \"Cantarell\", \"Fira Sans\",\n    \"Droid Sans\", \"Helvetica Neue\", sans-serif;\n  -webkit-font-smoothing: antialiased;\n  --removed-body-scroll-bar-size: 0px;\n  font-size: 1.25rem;\n  font-weight: 600;\n  box-sizing: border-box;\n  outline: 0px;\n  background: rgb(255, 255, 255);\n  box-shadow: rgba(0, 0, 0, 0.05) 0px 1px 2px 0px;\n  color: inherit;\n  min-width: 14rem;\n  padding-top: 0.5rem;\n  padding-bottom: 0.5rem;\n  z-index: 1;\n  border-radius: 0.375rem;\n  border: 0px;\n  transform-origin: left top;\n  opacity: ", ";\n  visibility: ", ";\n  transform: ", ";\n"])), function (props) {
  return props.hidden ? "0" : "1";
}, function (props) {
  return props.hidden ? "hidden" : "visible";
}, function (props) {
  return props.hidden ? "scale(0.8) translateZ(0px)" : "none";
});
var MenuList = function MenuList(_ref) {
  var children = _ref.children,
      hidden = _ref.hidden;

  var _useWindowDimensions = useWindowDimensions(),
      width = _useWindowDimensions.width;

  return React__default.createElement(MenuListPositioner, {
    hidden: hidden,
    placement: width > 765 ? "bottom-start" : "bottom-end"
  }, React__default.createElement(MenuListContainer, {
    hidden: hidden
  }, children));
};
var MenuItem = /*#__PURE__*/styled__default.button(_templateObject3$1 || (_templateObject3$1 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  -webkit-font-smoothing: antialiased;\n  --removed-body-scroll-bar-size: 0px;\n  visibility: visible;\n  border-width: 0px;\n  border-style: solid;\n  box-sizing: border-box;\n  text-decoration: none;\n  user-select: none;\n  display: flex;\n  width: 100%;\n  align-items: center;\n  text-align: left;\n  flex: 0 0 auto;\n  outline: 0px;\n  padding: 0.4rem 0.8rem;\n  transition: background 50ms ease-in 0s;\n  font-size: 20px;\n  background: transparent;\n  overflow: visible;\n  box-shadow: none !important;\n  line-height: inherit;\n  color: inherit;\n  cursor: \"pointer\";\n  opacity: \"1.0\";\n  :disabled {\n    opacity: 0.4;\n    cursor: not-allowed;\n  }\n"]))); // utils

function getWindowDimensions() {
  var _window = window,
      width = _window.innerWidth,
      height = _window.innerHeight;
  return {
    width: width,
    height: height
  };
}

function useWindowDimensions() {
  var _useState = React.useState(getWindowDimensions()),
      windowDimensions = _useState[0],
      setWindowDimensions = _useState[1];

  React.useEffect(function () {
    function handleResize() {
      setWindowDimensions(getWindowDimensions());
    }

    window.addEventListener("resize", handleResize);
    return function () {
      return window.removeEventListener("resize", handleResize);
    };
  }, []);
  return windowDimensions;
}

var _templateObject$8, _templateObject2$3, _templateObject3$2, _templateObject4, _templateObject5;
var ModalHeader = /*#__PURE__*/styled__default.header(_templateObject$8 || (_templateObject$8 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  &&& {\n    padding: 1rem 1.5rem;\n    font-size: 1.25rem;\n    font-weight: 600;\n    border-width: 0px;\n    border-style: solid;\n    box-sizing: border-box;\n  }\n"])));
var ModalOverlay = /*#__PURE__*/styled__default.div(_templateObject2$3 || (_templateObject2$3 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  &&& {\n    opacity: 1;\n    position: fixed;\n    left: 0px;\n    top: 0px;\n    width: 100vw;\n    height: 100vh;\n    background: rgba(0, 0, 0, 0.48);\n    z-index: 1400;\n  }\n"])));
var ModalBody = /*#__PURE__*/styled__default(Box)(_templateObject3$2 || (_templateObject3$2 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  &&& {\n    padding: ", ";\n    flex: 1 1 0%;\n    overflow: auto;\n  }\n"])), function (props) {
  return props.padding || "0.5rem 1.5rem";
}); // type ModalContentProps = {
//   backgroundImage?: string;
//   backgroundPosition?: string;
// };

var ModalContent = /*#__PURE__*/styled__default.section(_templateObject4 || (_templateObject4 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  &&& {\n    display: flex;\n    background-color: #f5f5f5;\n    background-repeat: no-repeat;\n    flex-direction: column;\n    position: relative;\n    width: 100%;\n    outline: 0px;\n    border: 2px solid #4d4d4d;\n    box-sizing: border-box;\n    border-radius: 15px;\n    padding: 0.5rem;\n    color: inherit;\n    margin-top: 3.75rem;\n    margin-bottom: 3.75rem;\n    z-index: 1400;\n    min-height: 20rem;\n    max-height: calc(100vh - 7.5rem);\n    box-shadow: rgb(0 0 0 / 10%) 0px 10px 15px -3px, rgb(0 0 0 / 5%) 0px 4px 6px -2px;\n    max-width: 28rem;\n  }\n"])));
var ModalContentContainer = /*#__PURE__*/styled__default(Box)(_templateObject5 || (_templateObject5 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  &&& {\n    display: flex;\n    width: 100vw;\n    height: 100vh;\n    position: fixed;\n    left: 0px;\n    top: 0px;\n    z-index: 1400;\n    justify-content: center;\n    align-items: center;\n    overflow: hidden;\n  }\n"])));

var _templateObject$9;
function getStackStyles(column, spacing) {
  if (column) {
    return "\n          margin-top: " + spacing + ";\n          margin-left: 0;\n          ";
  } else {
    return "\n        margin-left: " + spacing + ";\n        margin-top: 0;\n        ";
  }
}
var Stack = /*#__PURE__*/styled__default(Box)(_templateObject$9 || (_templateObject$9 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  &&& {\n    display: flex;\n    margin: ", ";\n    text-align: ", ";\n    justify-content: ", ";\n    align-items: ", ";\n    margin-inline-start: ", ";\n    flex-direction: ", ";\n    background-color: ", ";\n    border-radius: ", ";\n\n    & > * {\n      &:not(:first-child) {\n        ", "\n      }\n    }\n  }\n"])), function (props) {
  return props.margin;
}, function (props) {
  return props.textAlign;
}, function (props) {
  return props.justifyContent;
}, function (props) {
  return props.alignItems;
}, function (props) {
  return props.marginInlineStart || "0px";
}, function (props) {
  return props.column ? "column" : "row";
}, function (props) {
  return props.colorScheme;
}, function (props) {
  return props.borderRadius;
}, function (props) {
  var _props$spacing;

  return getStackStyles(props.column, props.theme.space[(_props$spacing = props.spacing) != null ? _props$spacing : 0]);
});

var _templateObject$a;

function truncate(noOfLines) {
  return "\n      -webkit-line-clamp: " + noOfLines + ";\n      display: -webkit-box;\n      -webkit-box-orient: vertical;\n      overflow: hidden;\n      ";
}

var Text = /*#__PURE__*/styled__default.p(_templateObject$a || (_templateObject$a = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  &&& {\n    color: ", ";\n    padding: ", ";\n    line-height: ", ";\n    letter-spacing: ", ";\n    font-style: ", ";\n    font-family: ", ";\n    font-weight: ", ";\n    font-size: ", ";\n    text-transform: ", ";\n    text-align: ", ";\n    margin: ", ";\n    margin-inline-start: ", ";\n    overflow: ", ";\n    flex: ", ";\n    ", ";\n    border-width: 0;\n    border-style: solid;\n    box-sizing: border-box;\n  }\n"])), function (props) {
  return props.color || "black";
}, function (props) {
  return props.padding;
}, function (props) {
  return props.lineHeight;
}, function (props) {
  return props.letterSpacing;
}, function (props) {
  return props.fontStyle || "normal";
}, function (props) {
  return props.fontFamily || "Roboto";
}, function (props) {
  return props.fontWeight || "400";
}, function (props) {
  return props.fontSize || "1rem";
}, function (props) {
  return props.textTransform || "capitalize";
}, function (props) {
  return props.textAlign;
}, function (props) {
  return props.margin || "0px";
}, function (props) {
  return props.marginInlineStart;
}, function (props) {
  return props.overflow;
}, function (props) {
  return props.flex;
}, function (props) {
  return props.noOfLines && truncate(props.noOfLines);
});

var theme = {
  space: {
    px: "1px",
    0: "0",
    0.5: "0.125rem",
    1: "0.25rem",
    1.5: "0.375rem",
    2: "0.5rem",
    2.5: "0.625rem",
    3: "0.75rem",
    3.5: "0.875rem",
    4: "1rem",
    5: "1.25rem",
    6: "1.5rem",
    7: "1.75rem",
    8: "2rem",
    9: "2.25rem",
    10: "2.5rem",
    12: "3rem",
    14: "3.5rem",
    16: "4rem",
    20: "5rem",
    24: "6rem",
    28: "7rem",
    32: "8rem",
    36: "9rem",
    40: "10rem",
    44: "11rem",
    48: "12rem",
    52: "13rem",
    56: "14rem",
    60: "15rem",
    64: "16rem",
    72: "18rem",
    80: "20rem",
    96: "24rem"
  },
  fonts: {
    heading: "Cooper Hewitt",
    body: "Roboto",
    mono: "Roboto Mono"
  },
  fontSizes: {
    xs: "0.75rem",
    sm: "0.875rem",
    md: "1rem",
    lg: "1.125rem",
    xl: "1.25rem",
    "2xl": "1.5rem",
    "3xl": "1.875rem",
    "4xl": "2.25rem",
    "5xl": "3rem",
    "6xl": "3.75rem",
    "7xl": "4.5rem",
    "8xl": "6rem",
    "9xl": "8rem"
  },
  sizes: {
    lg: {
      h: 12,
      minW: 12,
      fontSize: "lg",
      px: 6
    },
    md: {
      h: 10,
      minW: 10,
      fontSize: "md",
      px: 4
    },
    sm: {
      h: 8,
      minW: 8,
      fontSize: "sm",
      px: 3
    },
    xs: {
      h: 6,
      minW: 6,
      fontSize: "xs",
      px: 2
    }
  }
};

var Header = function Header(props) {
  var title = props.title,
      subTitle = props.subTitle,
      warningIcon = props.warningIcon,
      successIcon = props.successIcon,
      spinner = props.spinner,
      onClose = props.onClose,
      options = props.options,
      handleBack = props.handleBack;
  return React__default.createElement(React__default.Fragment, null, React__default.createElement(ModalHeader, null, React__default.createElement(Stack, {
    justifyContent: "space-between"
  }, React__default.createElement(Stack, {
    alignItems: "center",
    spacing: 2
  }, warningIcon && React__default.createElement(IconBox, null, React__default.createElement(WarningIcon, null)), successIcon && React__default.createElement("img", {
    src: "https://cdn.connext.network/success.svg",
    alt: "success"
  }), spinner && React__default.createElement(Spinner, null), React__default.createElement(Text, {
    fontWeight: "700",
    fontFamily: "Cooper Hewitt",
    textTransform: "uppercase",
    fontSize: "1.5rem",
    lineHeight: "30px"
  }, title)), React__default.createElement(Stack, null, handleBack && handleBack(), options && options(), onClose && onClose())), subTitle && React__default.createElement("div", null, subTitle)));
};

var _templateObject$b;
var ModalFooter = /*#__PURE__*/styled__default.div(_templateObject$b || (_templateObject$b = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  padding-left: 1.5rem;\n  padding-right: 1.5rem;\n  padding-top: 1rem;\n  padding-bottom: 1rem;\n  border-width: 0;\n  border-style: solid;\n  box-sizing: border-box;\n"])));

var Footer = function Footer() {
  return React__default.createElement(React__default.Fragment, null, React__default.createElement(ModalFooter, null, React__default.createElement(Text, {
    color: "#999999",
    lineHeight: "14px",
    letterSpacing: "0.2em",
    fontWeight: "700",
    textTransform: "uppercase",
    textAlign: "center",
    fontSize: "0.75rem"
  }, "Powered by Connext")));
};

var _templateObject$c;

var NetworkBar = function NetworkBar(props) {
  var senderChainInfo = props.senderChainInfo,
      receiverChainInfo = props.receiverChainInfo,
      receiverAddress = props.receiverAddress;
  return React__default.createElement(React__default.Fragment, null, React__default.createElement(Divider, null), React__default.createElement(Stack, {
    column: true,
    spacing: 4
  }, React__default.createElement(Stack, {
    justifyContent: "space-between"
  }, React__default.createElement(Box, null, React__default.createElement(Text, {
    fontSize: "0.75rem",
    textTransform: "uppercase",
    fontFamily: "Cooper Hewitt",
    fontWeight: "700",
    lineHeight: "18px",
    letterSpacing: "0.05em",
    color: "#26B1D6"
  }, senderChainInfo.name), React__default.createElement(Link, {
    href: vectorSdk.getExplorerLinkForAsset(senderChainInfo.chainId, senderChainInfo.assetId),
    target: "_blank"
  }, React__default.createElement(Text, {
    fontSize: "1.25rem",
    textTransform: "uppercase",
    fontFamily: "Cooper Hewitt",
    fontWeight: "700",
    lineHeight: "30px",
    letterSpacing: "0.05em"
  }, senderChainInfo.assetName))), React__default.createElement("img", {
    src: "https://cdn.connext.network/network_arrow.svg",
    alt: "arrow",
    width: "32"
  }), React__default.createElement(Box, null, React__default.createElement(Text, {
    fontSize: "0.75rem",
    textTransform: "uppercase",
    fontFamily: "Cooper Hewitt",
    fontWeight: "700",
    lineHeight: "18px",
    letterSpacing: "0.05em",
    color: "#2964C5"
  }, receiverChainInfo.name), " ", React__default.createElement(Link, {
    href: vectorSdk.getExplorerLinkForAsset(receiverChainInfo.chainId, receiverChainInfo.assetId),
    target: "_blank"
  }, React__default.createElement(Text, {
    fontSize: "1.25rem",
    textTransform: "uppercase",
    fontFamily: "Cooper Hewitt",
    fontWeight: "700",
    lineHeight: "30px",
    letterSpacing: "0.05em"
  }, receiverChainInfo.assetName)))), receiverAddress && React__default.createElement(Stack, {
    column: true,
    spacing: 1
  }, React__default.createElement(Text, {
    fontWeight: "400",
    fontSize: "12px",
    textTransform: "capitalize",
    color: "#666666"
  }, "Receiver Address"), React__default.createElement(InputGroup, null, React__default.createElement(Input, {
    id: "address",
    name: "address",
    value: receiverAddress,
    inputMode: "search",
    title: "receiver Address",
    // styled
    body: "md",
    fontSize: "13px",
    // misc
    readOnly: true
  })))));
};
var Divider = /*#__PURE__*/styled__default.hr(_templateObject$c || (_templateObject$c = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  border: 0.25px solid rgb(102, 102, 102);\n  margin-inline-start: 0px;\n  box-sizing: content-box;\n  height: 0px;\n  overflow: visible;\n  width: 100%;\n  opacity: 0.6;\n"])));

var Options = function Options(props) {
  var _useState = React.useState(false),
      isListOpen = _useState[0],
      setIsListOpen = _useState[1];

  var state = props.state,
      onClose = props.onClose,
      handleSetState = props.handleSetState,
      handleUserInfoButton = props.handleUserInfoButton;
  return React__default.createElement(React__default.Fragment, null, React__default.createElement("div", null, React__default.createElement(MenuButton, {
    onClick: function onClick() {
      return setIsListOpen(!isListOpen);
    },
    isSelected: !!isListOpen
  }), React__default.createElement(MenuList, {
    hidden: !isListOpen
  }, React__default.createElement(MenuItem, {
    onClick: function onClick() {
      handleSetState(SCREEN_STATES.SWAP);
    },
    disabled: [SCREEN_STATES.LOADING, SCREEN_STATES.STATUS].concat(Object.values(ERROR_STATES)).includes(state) ? true : false
  }, "Home"), React__default.createElement(MenuItem, {
    onClick: function onClick() {
      handleSetState(SCREEN_STATES.RECOVER);
    },
    disabled: [SCREEN_STATES.LOADING, SCREEN_STATES.STATUS].concat(Object.values(ERROR_STATES)).includes(state) ? true : false
  }, "Recovery"), React__default.createElement(MenuItem, {
    onClick: function onClick() {
      handleSetState(SCREEN_STATES.HISTORY);
    },
    disabled: [SCREEN_STATES.LOADING, SCREEN_STATES.STATUS].includes(state) ? true : false
  }, "Transfer History"), React__default.createElement(MenuItem, {
    onClick: function onClick() {
      return window.open("https://support.connext.network", "_blank");
    }
  }, "Support"), React__default.createElement(MenuItem, {
    disabled: [SCREEN_STATES.LOADING, SCREEN_STATES.STATUS].includes(state) ? true : false,
    onClick: handleUserInfoButton
  }, "User Info"), React__default.createElement(MenuItem, {
    disabled: [SCREEN_STATES.LOADING, SCREEN_STATES.STATUS].includes(state) ? true : false,
    onClick: onClose
  }, "Close"))));
};

var _templateObject$d;

var Loading = function Loading(props) {
  var message = props.message;
  var canvas = React.useRef(null);
  var animationContainer = React.useRef(null); // Resizes the canvas to match the parent element

  React.useEffect(function () {
    var resize = function resize() {
      if (animationContainer.current && canvas.current) {
        var _animationContainer$c = animationContainer.current.getBoundingClientRect(),
            w = _animationContainer$c.width,
            h = _animationContainer$c.height;

        canvas.current.width = w;
        canvas.current.height = h;
      }
    };

    resize();
  }); // Start the animation

  React.useEffect(function () {
    var rive = riveJs.Rive["new"]({
      src: "https://cdn.connext.network/loading_darkBg.riv",
      canvas: canvas.current,
      // animation: animation,
      autoplay: true,
      layout: new riveJs.Layout("cover", "center")
    });
    return function () {
      return rive.stop();
    };
  }, []);
  return React__default.createElement(React__default.Fragment, null, React__default.createElement(ModalContent, null, React__default.createElement(ModalBody, {
    padding: "1rem"
  }, React__default.createElement(Stack, {
    column: true,
    alignItems: "center"
  }, React__default.createElement(AppLogo, {
    ref: animationContainer
  }, React__default.createElement("canvas", {
    ref: canvas
  })), React__default.createElement(Text, {
    fontSize: "1.25rem"
  }, message))), React__default.createElement(Footer, null)));
};
var AppLogo = /*#__PURE__*/styled__default.div(_templateObject$d || (_templateObject$d = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  &&& {\n    pointer-events: none;\n    clip-path: circle(60px at center);\n  }\n"])));

var Status = function Status(props) {
  var title = props.title,
      message = props.message,
      senderChainInfo = props.senderChainInfo,
      receiverChainInfo = props.receiverChainInfo,
      receiverAddress = props.receiverAddress,
      options = props.options,
      _props$showNetworkBar = props.showNetworkBar,
      showNetworkBar = _props$showNetworkBar === void 0 ? true : _props$showNetworkBar;
  return React__default.createElement(React__default.Fragment, null, React__default.createElement(ModalContent, {
    id: "modalContent"
  }, React__default.createElement(Header, {
    title: title,
    spinner: true,
    options: options
  }), React__default.createElement(ModalBody, null, React__default.createElement(Stack, {
    column: true,
    spacing: 7
  }, React__default.createElement(Stack, {
    column: true,
    spacing: 2
  }, React__default.createElement(Text, {
    fontSize: "1rem"
  }, message), React__default.createElement(Text, {
    fontSize: "14px",
    color: "#666666"
  }, "Do not close or refresh.")), showNetworkBar && React__default.createElement(NetworkBar, {
    senderChainInfo: senderChainInfo,
    receiverChainInfo: receiverChainInfo,
    receiverAddress: receiverAddress
  }))), React__default.createElement(Footer, null)));
};

var Success = function Success(props) {
  var rawWebProvider = props.rawWebProvider,
      amount = props.amount,
      transactionId = props.transactionId,
      senderChainInfo = props.senderChainInfo,
      receiverChainInfo = props.receiverChainInfo,
      receiverAddress = props.receiverAddress,
      onClose = props.onClose,
      options = props.options;

  var _useState = React.useState(false),
      copiedAddress = _useState[0],
      setCopiedAddress = _useState[1];

  var _useState2 = React.useState(),
      errorMessage = _useState2[0],
      setErrorMessage = _useState2[1];

  var switchAndAddToken = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee() {
      var injectedProvider, network, defaultMetmaskNetworks, message;
      return runtime_1.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              injectedProvider = new providers.Web3Provider(rawWebProvider);
              _context.next = 3;
              return injectedProvider.getNetwork();

            case 3:
              network = _context.sent;

              if (!(receiverChainInfo.chainId !== network.chainId)) {
                _context.next = 13;
                break;
              }

              defaultMetmaskNetworks = [1, 3, 4, 5, 42];

              if (defaultMetmaskNetworks.includes(receiverChainInfo.chainId)) {
                _context.next = 11;
                break;
              }

              _context.next = 9;
              return ethereum.request({
                method: "wallet_addEthereumChain",
                params: [receiverChainInfo == null ? void 0 : receiverChainInfo.chainParams]
              });

            case 9:
              _context.next = 13;
              break;

            case 11:
              message = "Please connect your wallet to the " + receiverChainInfo.name + " : " + receiverChainInfo.chainId + " network";
              setErrorMessage(message);

            case 13:
              _context.next = 15;
              return ethereum.request({
                method: "wallet_watchAsset",
                params: {
                  type: "ERC20",
                  options: {
                    address: receiverChainInfo.assetId,
                    symbol: receiverChainInfo.assetName,
                    decimals: receiverChainInfo.assetDecimals
                  }
                }
              });

            case 15:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function switchAndAddToken() {
      return _ref.apply(this, arguments);
    };
  }();

  return React__default.createElement(React__default.Fragment, null, React__default.createElement(ModalContent, {
    id: "modalContent"
  }, React__default.createElement(Header, {
    title: "Success",
    successIcon: true,
    options: options,
    onClose: onClose
  }), React__default.createElement(ModalBody, null, React__default.createElement(Stack, {
    column: true,
    spacing: 7
  }, React__default.createElement(Box, null, React__default.createElement(Stack, {
    column: true,
    spacing: 5
  }, React__default.createElement(Stack, null, React__default.createElement(Text, {
    fontSize: "1.5rem",
    fontFamily: "Cooper Hewitt",
    fontWeight: "700",
    lineHeight: "30px",
    flex: "auto"
  }, vectorSdk.truncate(amount, 6), " ", receiverChainInfo.assetName), React__default.createElement(Button, {
    size: "sm",
    borderRadius: "5px",
    colorScheme: "blue",
    border: "none",
    borderStyle: "none",
    color: "white",
    casing: "uppercase",
    onClick: function onClick() {
      return window.open(vectorSdk.getExplorerLinkForTx(receiverChainInfo.chainId, transactionId), "_blank");
    }
  }, "view tx")), React__default.createElement(Stack, {
    column: true,
    spacing: 2
  }, React__default.createElement(Text, {
    fontSize: "1rem"
  }, "Add " + receiverChainInfo.assetName + " on " + receiverChainInfo.name + " in your wallet."), errorMessage && React__default.createElement(Text, {
    flex: "auto",
    fontSize: "0.75rem",
    textAlign: "center"
  }, errorMessage), !!rawWebProvider && receiverChainInfo.assetId !== constants.AddressZero && // @ts-ignore
  ethereum && // @ts-ignore
  ethereum.isMetaMask ? React__default.createElement(Button, {
    size: "lg",
    onClick: switchAndAddToken
  }, "Add ", receiverChainInfo.assetName, " to ", receiverChainInfo.name) : React__default.createElement(InputGroup, {
    borderRadius: "15px"
  }, React__default.createElement(Input, {
    body: "lg",
    id: "assetId",
    name: "assetId",
    value: receiverChainInfo.assetId,
    inputMode: "search",
    title: "Receiver AssetId",
    // styling
    fontSize: "14px",
    flex: "auto",
    paddingLeft: "12px",
    paddingRight: "0px",
    // misc
    readOnly: true
  }), React__default.createElement(IconButton, {
    "aria-label": "Clipboard",
    onClick: function onClick() {
      console.log("Copying: " + receiverChainInfo.assetId);
      navigator.clipboard.writeText(receiverChainInfo.assetId);
      setCopiedAddress(true);
      setTimeout(function () {
        return setCopiedAddress(false);
      }, 5000);
    }
  }, React__default.createElement(IconBox, {
    width: "1.5rem"
  }, !copiedAddress ? React__default.createElement(CopyIcon, null) : React__default.createElement(CheckCircleIcon, null))))))), senderChainInfo && receiverChainInfo && React__default.createElement(NetworkBar, {
    senderChainInfo: senderChainInfo,
    receiverChainInfo: receiverChainInfo,
    receiverAddress: receiverAddress
  }))), React__default.createElement(Footer, null)));
};

var Error$1 = function Error(props) {
  var _ref, _error$context$counte, _error$context, _error$context$counte2, _error$context$counte3, _error$context$counte4, _error$context$counte5, _error$context$counte6, _error$context2, _error$context2$count;

  var error = props.error,
      title = props.title,
      retry = props.retry,
      switchNetwork = props.switchNetwork,
      options = props.options,
      handleBack = props.handleBack,
      handleRecoveryButton = props.handleRecoveryButton,
      senderChannelAddress = props.senderChannelAddress,
      recipientChannelAddress = props.recipientChannelAddress,
      state = props.state,
      senderChainInfo = props.senderChainInfo,
      receiverChainInfo = props.receiverChainInfo,
      receiverAddress = props.receiverAddress;

  var _useState = React.useState(false),
      copiedMessage = _useState[0],
      setCopiedMessage = _useState[1];

  return React__default.createElement(React__default.Fragment, null, React__default.createElement(ModalContent, {
    id: "modalContent"
  }, React__default.createElement(Header, {
    title: title,
    warningIcon: true,
    handleBack: handleBack,
    options: options
  }), React__default.createElement(ModalBody, null, React__default.createElement(Stack, {
    column: true,
    spacing: 5
  }, React__default.createElement(Stack, {
    column: true,
    spacing: 4
  }, React__default.createElement(Stack, {
    column: true,
    spacing: 2
  }, React__default.createElement(Stack, null, React__default.createElement(Text, {
    fontSize: "0.875rem",
    flex: "auto",
    noOfLines: 3,
    color: "crimson",
    lineHeight: "24px"
  }, (_ref = (_error$context$counte = error == null ? void 0 : (_error$context = error.context) == null ? void 0 : (_error$context$counte2 = _error$context.counterpartyError) == null ? void 0 : (_error$context$counte3 = _error$context$counte2.context) == null ? void 0 : (_error$context$counte4 = _error$context$counte3.validationContext) == null ? void 0 : (_error$context$counte5 = _error$context$counte4.generateContext) == null ? void 0 : (_error$context$counte6 = _error$context$counte5.reconcileError) == null ? void 0 : _error$context$counte6.message) != null ? _error$context$counte : error == null ? void 0 : (_error$context2 = error.context) == null ? void 0 : (_error$context2$count = _error$context2.counterpartyError) == null ? void 0 : _error$context2$count.message) != null ? _ref : error.message), React__default.createElement(IconButton, {
    "aria-label": "Clipboard",
    onClick: function onClick() {
      var message = "senderChannelAddress: " + senderChannelAddress + ", recipientChannelAddress: " + recipientChannelAddress + ", error: " + error.message;
      console.log("Copying: " + message);
      navigator.clipboard.writeText(message);
      setCopiedMessage(true);
      setTimeout(function () {
        return setCopiedMessage(false);
      }, 5000);
    }
  }, React__default.createElement(IconBox, {
    width: "1.5rem"
  }, !copiedMessage ? React__default.createElement(CopyIcon, null) : React__default.createElement(CheckCircleIcon, null)))), React__default.createElement(Box, null, state === ERROR_STATES.ERROR_TRANSFER && React__default.createElement(Text, {
    fontSize: "0.875rem",
    lineHeight: "24px",
    textTransform: "initial"
  }, "An error occurred during the transfer. Your funds are safe and the transfer can be retried."), React__default.createElement(Text, {
    fontSize: "0.875rem",
    lineHeight: "24px",
    textTransform: "initial"
  }, "Support help can be found on our", " ", React__default.createElement(Link, {
    href: "https://support.connext.network",
    target: "_blank",
    color: "green"
  }, "Support Portal"), " ", "."))), React__default.createElement(Stack, {
    column: true,
    spacing: 2
  }, state === ERROR_STATES.ERROR_NETWORK && React__default.createElement(Button, {
    size: "lg",
    onClick: switchNetwork
  }, "Switch to ", senderChainInfo == null ? void 0 : senderChainInfo.name), state !== ERROR_STATES.ERROR_NETWORK && retry && React__default.createElement(Button, {
    size: "lg",
    onClick: retry
  }, "Retry"), state === ERROR_STATES.ERROR_TRANSFER && React__default.createElement(Button, {
    size: "lg",
    onClick: handleRecoveryButton
  }, "Recover Funds"))), senderChainInfo && receiverChainInfo && React__default.createElement(NetworkBar, {
    senderChainInfo: senderChainInfo,
    receiverChainInfo: receiverChainInfo,
    receiverAddress: receiverAddress
  }))), React__default.createElement(Footer, null)));
};

var Swap = function Swap(props) {
  var amountError = props.amountError,
      vaultName = props.vaultName,
      userBalance = props.userBalance,
      userAddress = props.userAddress,
      senderChainInfo = props.senderChainInfo,
      receiverChainInfo = props.receiverChainInfo,
      receiverAddress = props.receiverAddress,
      senderAmount = props.senderAmount,
      recipientAmount = props.recipientAmount,
      existingChannelBalance = props.existingChannelBalance,
      feeQuote = props.feeQuote,
      swapRate = props.swapRate,
      isLoad = props.isLoad,
      inputReadOnly = props.inputReadOnly,
      onUserInput = props.onUserInput,
      swapRequest = props.swapRequest,
      options = props.options;

  var _useState = React.useState(userAddress ? receiverAddress !== userAddress ? false : true : true),
      check = _useState[0],
      setCheck = _useState[1];

  function escapeRegExp(string) {
    return string.replace(/[.*+?^${}()|[\]\\]/g, "\\$&"); // $& means the whole matched string
  }

  var inputRegex = RegExp("^\\d*(?:\\\\[.])?\\d*$"); // match escaped "." characters via in a non-capturing group

  var enforcer = function enforcer(currentInput, receiveExactAmount) {
    if (currentInput === "" || inputRegex.test(escapeRegExp(currentInput))) {
      onUserInput(currentInput, receiveExactAmount);
    }
  };

  var handleSubmit = function handleSubmit() {
    if (senderAmount) {
      swapRequest();
    }
  };

  React.useEffect(function () {
    var effect = /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee() {
        return runtime_1.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (senderAmount) {
                  enforcer(senderAmount, false);
                }

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function effect() {
        return _ref.apply(this, arguments);
      };
    }();

    effect(); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [senderAmount]);
  return React__default.createElement(React__default.Fragment, null, React__default.createElement(ModalContent, {
    id: "modalContent"
  }, React__default.createElement(Header, {
    title: "Send Amount",
    options: options
  }), React__default.createElement(ModalBody, null, React__default.createElement(Stack, {
    column: true,
    spacing: 5
  }, React__default.createElement(Stack, {
    column: true,
    spacing: 4
  }, React__default.createElement(Stack, {
    column: true,
    spacing: 3
  }, existingChannelBalance && React__default.createElement(Text, {
    flex: "auto",
    fontSize: "0.875rem",
    fontStyle: "italic",
    textTransform: "none",
    color: "#333333"
  }, "You are adding more funds for Swap, your existing channel currently holds", " ", vectorSdk.truncate(existingChannelBalance, 4), " ", senderChainInfo.assetName), React__default.createElement(Stack, {
    column: true
  }, React__default.createElement(Stack, {
    column: true,
    spacing: 1
  }, React__default.createElement(Stack, null, React__default.createElement(Text, {
    flex: "auto",
    fontSize: "0.75rem"
  }, "You send"), userBalance && React__default.createElement(Text, {
    fontSize: "0.75rem",
    fontFamily: "Roboto Mono",
    textTransform: "uppercase",
    textAlign: "end",
    color: "#757575"
  }, "Balance: ", vectorSdk.truncate(userBalance, 4), " ", senderChainInfo.assetName)), React__default.createElement(Stack, {
    colorScheme: "white",
    alignItems: "center",
    borderRadius: "5px"
  }, React__default.createElement(InputGroup, {
    flex: "auto",
    colorScheme: "white"
  }, React__default.createElement(Input, {
    body: "lg",
    title: "Token Amount",
    "aria-describedby": "amount",
    // styling
    fontSize: "1rem",
    // universal input options
    inputMode: "decimal",
    autoComplete: "off",
    autoCorrect: "off",
    // text-specific options
    type: "text",
    pattern: "^[0-9]*[.,]?[0-9]*$",
    placeholder: "0.0",
    minLength: 1,
    maxLength: 79,
    spellCheck: "false",
    // value
    value: senderAmount,
    onChange: function onChange(event) {
      enforcer(event.target.value.replace(/,/g, "."), false);
    },
    readOnly: inputReadOnly ? true : false
  })), existingChannelBalance && React__default.createElement(Stack, null, React__default.createElement(Text, {
    margin: "0 10px 0 0",
    fontFamily: "Roboto Mono",
    textTransform: "uppercase",
    fontSize: "1rem",
    color: "#333333"
  }, "+"), React__default.createElement(Text, {
    margin: "0 20px 0 0",
    fontFamily: "Roboto Mono",
    textTransform: "uppercase",
    fontSize: "1rem",
    color: "#333333"
  }, vectorSdk.truncate(existingChannelBalance, 4))), userBalance && React__default.createElement(Button, {
    size: "xs",
    colorScheme: "#DEDEDE",
    color: "#737373",
    borderRadius: "5px",
    border: "none",
    borderStyle: "none",
    casing: "uppercase",
    marginRight: "10px!important",
    height: "1.5rem",
    disabled: inputReadOnly ? true : false,
    onClick: function onClick() {
      enforcer(userBalance, false);
    }
  }, "max"), React__default.createElement(Text, {
    margin: "0 10px 0 0",
    fontFamily: "Roboto Mono",
    textTransform: "uppercase",
    fontSize: "1rem",
    color: "#333333"
  }, senderChainInfo.assetName))), React__default.createElement(Stack, {
    justifyContent: "center",
    margin: "10px 0px 0px 0px!important"
  }, React__default.createElement("img", {
    src: "https://cdn.connext.network/arrow_downward.svg",
    width: "24px",
    height: "24px",
    alt: "arrow_downward"
  })), React__default.createElement(Stack, {
    column: true,
    spacing: 1
  }, React__default.createElement(Text, {
    fontSize: "0.75rem"
  }, "Recipient gets"), React__default.createElement(Stack, {
    colorScheme: "white",
    alignItems: "center",
    borderRadius: "5px"
  }, React__default.createElement(InputGroup, {
    flex: "auto",
    colorScheme: "white"
  }, React__default.createElement(Input, {
    body: "lg",
    title: "Token Amount",
    "aria-describedby": "amount",
    // styling
    fontSize: "1rem",
    // universal input options
    inputMode: "decimal",
    autoComplete: "off",
    autoCorrect: "off",
    // text-specific options
    type: "text",
    pattern: "^[0-9]*[.,]?[0-9]*$",
    placeholder: "0.0",
    minLength: 1,
    maxLength: 79,
    spellCheck: "false",
    // value
    value: recipientAmount,
    onChange: function onChange(event) {
      enforcer(event.target.value.replace(/,/g, "."), true);
    },
    // readOnly={inputReadOnly ? true : false}
    readOnly: true
  })), React__default.createElement(Text, {
    margin: "0 10px 0 0",
    fontFamily: "Roboto Mono",
    textTransform: "uppercase",
    fontSize: "1rem",
    color: "#333333"
  }, receiverChainInfo.assetName)))), React__default.createElement(Stack, {
    column: true,
    spacing: 2
  }, swapRate && React__default.createElement(Stack, null, React__default.createElement(Text, {
    fontSize: "0.875rem",
    fontWeight: "700",
    flex: "auto",
    color: "#666666"
  }, "Price:"), React__default.createElement(Text, {
    textTransform: "none",
    fontSize: "0.875rem",
    fontFamily: "Roboto Mono",
    color: "#666666",
    fontWeight: "700"
  }, vectorSdk.truncate(swapRate, 6), " ", React__default.createElement("span", {
    style: {
      color: "#26B1D6"
    }
  }, senderChainInfo.assetName), " ", "per 1 ", React__default.createElement("span", {
    style: {
      color: "#2964C5"
    }
  }, receiverChainInfo.assetName))), feeQuote && React__default.createElement(Stack, null, React__default.createElement(Text, {
    fontSize: "0.875rem",
    fontWeight: "700",
    flex: "auto",
    color: "#666666"
  }, "Estimated Fees:"), React__default.createElement(Text, {
    fontSize: "0.875rem",
    fontFamily: "Roboto Mono",
    color: "#666666",
    fontWeight: "700"
  }, vectorSdk.truncate(feeQuote, 6), " ", senderChainInfo.assetName)))), !!amountError && React__default.createElement(Text, {
    flex: "auto",
    fontSize: "0.75rem",
    textAlign: "center",
    color: "crimson"
  }, amountError), userAddress && receiverAddress !== userAddress && React__default.createElement(Stack, {
    spacing: 1
  }, React__default.createElement("input", {
    type: "checkbox",
    name: "confirmation",
    checked: check,
    onChange: function onChange() {
      return setCheck(!check);
    }
  }), React__default.createElement(Text, {
    flex: "auto",
    fontSize: "0.875rem"
  }, "Please confirm the receiver address on ", receiverChainInfo.name)), vaultName && React__default.createElement(Stack, {
    spacing: 1
  }, React__default.createElement(Text, {
    flex: "auto",
    fontSize: "0.875rem"
  }, "Destination Vault: ", vaultName)), React__default.createElement(Button, {
    size: "lg",
    type: "submit",
    disabled: !!amountError || !senderAmount || isLoad || !check ? true : false,
    onClick: handleSubmit
  }, isLoad ? "Waiting for tx + " + vectorTypes.getConfirmationsForChain(senderChainInfo.chainId) + " confirmations" : "Swap")), React__default.createElement(NetworkBar, {
    senderChainInfo: senderChainInfo,
    receiverChainInfo: receiverChainInfo,
    receiverAddress: receiverAddress
  }))), React__default.createElement(Footer, null)));
};

var SwapListener = function SwapListener(props) {
  var showTimer = props.showTimer,
      senderChannelAddress = props.senderChannelAddress,
      senderChainInfo = props.senderChainInfo,
      receiverChainInfo = props.receiverChainInfo,
      receiverAddress = props.receiverAddress,
      options = props.options,
      handleBack = props.handleBack;

  var _useState = React.useState(false),
      copiedAddress = _useState[0],
      setCopiedAddress = _useState[1];

  var _useState2 = React.useState(false),
      running = _useState2[0],
      setRunning = _useState2[1];

  var _useState3 = React.useState(0),
      currentTimeSec = _useState3[0],
      setCurrentTimeSec = _useState3[1];

  var _useState4 = React.useState(0),
      currentTimeMin = _useState4[0],
      setCurrentTimeMin = _useState4[1];

  var _useState5 = React.useState(),
      watchInterval = _useState5[0],
      setWatchInterval = _useState5[1];

  var formatTime = function formatTime(val) {
    var value = val.toString();

    if (value.length < 2) {
      value = "0" + value;
    }

    return value;
  };

  React.useEffect(function () {
    if (showTimer) {
      if (!running) {
        setRunning(true);
        var watch = setInterval(function () {
          setCurrentTimeSec(function (prevSec) {
            if (prevSec >= 60) {
              setCurrentTimeMin(function (prevMin) {
                return prevMin + 1;
              });
              return 0;
            }

            return prevSec + 1;
          });
        }, 1000);
        setWatchInterval(watch);
      }
    } else {
      setRunning(false);
      clearInterval(watchInterval);
      setCurrentTimeSec(0);
      setCurrentTimeMin(0);
    }
  }, [showTimer, running, watchInterval]);
  return React__default.createElement(React__default.Fragment, null, React__default.createElement(ModalContent, {
    id: "modalContent"
  }, React__default.createElement(Header, {
    title: "Ready for transfer",
    handleBack: handleBack,
    options: options
  }), React__default.createElement(ModalBody, null, React__default.createElement(Stack, {
    column: true,
    spacing: 5
  }, React__default.createElement(Stack, {
    column: true,
    spacing: 3
  }, React__default.createElement(Box, null, React__default.createElement(Stack, {
    spacing: 8
  }, React__default.createElement(Stack, {
    column: true,
    spacing: 5
  }, React__default.createElement(Text, {
    fontSize: "1rem",
    fontWeight: "500"
  }, "Send ", React__default.createElement("span", {
    style: {
      color: "#2964C5"
    }
  }, senderChainInfo.assetName), " on", " ", React__default.createElement("span", {
    style: {
      color: "#2964C5"
    }
  }, senderChainInfo.name), " to the QR or address below."), React__default.createElement(Stack, {
    column: true,
    spacing: 3
  }, React__default.createElement(Text, {
    fontSize: "1rem"
  }, "Awaiting your transfer..."), React__default.createElement(Stack, {
    spacing: 4,
    alignItems: "center"
  }, React__default.createElement(Box, null, React__default.createElement(Spinner, null)), React__default.createElement(Text, {
    fontFamily: "Roboto Mono"
  }, formatTime(currentTimeMin), ":", formatTime(currentTimeSec))))), React__default.createElement(Box, {
    colorScheme: "white",
    borderRadius: "15px"
  }, React__default.createElement(QRCode, {
    value: senderChannelAddress,
    size: 150,
    style: {
      padding: "0.5rem"
    }
  })))), React__default.createElement(InputGroup, {
    borderRadius: "15px"
  }, React__default.createElement(Input, {
    body: "lg",
    id: "depositAddress",
    name: "address",
    value: senderChannelAddress,
    inputMode: "search",
    title: "Deposit Address",
    // styling
    fontSize: "14px",
    flex: "auto",
    paddingLeft: "12px",
    paddingRight: "0px",
    // misc
    readOnly: true
  }), React__default.createElement(IconButton, {
    "aria-label": "Clipboard",
    onClick: function onClick() {
      console.log("Copying: " + senderChannelAddress);
      navigator.clipboard.writeText(senderChannelAddress);
      setCopiedAddress(true);
      setTimeout(function () {
        return setCopiedAddress(false);
      }, 5000);
    }
  }, React__default.createElement(IconBox, {
    width: "1.5rem"
  }, !copiedAddress ? React__default.createElement(CopyIcon, null) : React__default.createElement(CheckCircleIcon, null))))), React__default.createElement(NetworkBar, {
    senderChainInfo: senderChainInfo,
    receiverChainInfo: receiverChainInfo,
    receiverAddress: receiverAddress
  }))), React__default.createElement(Footer, null)));
};

var Recover = function Recover(props) {
  var recover = props.recover,
      handleBack = props.handleBack,
      handleOptions = props.handleOptions,
      userAddress = props.userAddress,
      tokenAddress = props.tokenAddress;

  var _useState = React.useState(tokenAddress != null ? tokenAddress : constants.AddressZero),
      recoverTokenAddress = _useState[0],
      setRecoverTokenAddress = _useState[1];

  var _useState2 = React.useState(false),
      recoverTokenAddressError = _useState2[0],
      setRecoverTokenAddressError = _useState2[1];

  var _useState3 = React.useState(""),
      recoverWithdrawalAddress = _useState3[0],
      setRecoverWithdrawalAddress = _useState3[1];

  var _useState4 = React.useState(false),
      recoverWithdrawalAddressError = _useState4[0],
      setRecoverWithdrawalAddressError = _useState4[1];

  React.useEffect(function () {
    if (userAddress) setRecoverWithdrawalAddress(userAddress);
  }, [userAddress]);
  return React__default.createElement(React__default.Fragment, null, React__default.createElement(ModalContent, {
    id: "modalContent"
  }, React__default.createElement(Header, {
    title: "Recover lost funds",
    handleBack: handleBack,
    options: handleOptions
  }), React__default.createElement(ModalBody, null, React__default.createElement(Stack, {
    column: true,
    spacing: 5
  }, React__default.createElement(Text, {
    fontSize: "1rem",
    lineHeight: "24px"
  }, "Uh oh! Fill out the details below to attempt recovery of your assets from the state channels."), React__default.createElement(Box, null, React__default.createElement(Stack, {
    column: true,
    spacing: 5
  }, React__default.createElement(Stack, {
    column: true,
    spacing: 1
  }, React__default.createElement(Stack, null, React__default.createElement(Text, {
    fontSize: "0.875rem",
    flex: "auto",
    color: "#666666",
    fontWeight: "700"
  }, "Token Address"), React__default.createElement(Text, {
    fontSize: "0.875rem",
    color: "crimson",
    fontFamily: "Roboto Mono",
    fontWeight: "700"
  }, recoverTokenAddressError && "Must be an Ethereum address")), React__default.createElement(InputGroup, {
    colorScheme: "white",
    borderRadius: "15px"
  }, React__default.createElement(Input, {
    id: "tokenAddress",
    name: "Token Address",
    type: "search",
    body: "lg",
    placeholder: "0x...",
    // styling
    value: recoverTokenAddress,
    onChange: function onChange(event) {
      setRecoverTokenAddress(event.target.value);
      setRecoverTokenAddressError(!vectorSdk.isValidAddress(event.target.value));
    }
  }))), React__default.createElement(Stack, {
    column: true,
    spacing: 1
  }, React__default.createElement(Stack, null, React__default.createElement(Text, {
    fontSize: "0.875rem",
    flex: "auto",
    color: "#666666",
    fontWeight: "700"
  }, "Withdrawal Address"), React__default.createElement(Text, {
    fontSize: "0.875rem",
    color: "crimson",
    fontFamily: "Roboto Mono",
    fontWeight: "700"
  }, recoverWithdrawalAddressError && "Must be an Ethereum address")), React__default.createElement(InputGroup, {
    colorScheme: "white",
    borderRadius: "15px"
  }, React__default.createElement(Input, {
    id: "withdrawalAddress",
    name: "Withdrawal Address",
    type: "search",
    body: "lg",
    // styling
    placeholder: "0x...",
    onChange: function onChange(event) {
      setRecoverWithdrawalAddress(event.target.value);
      setRecoverWithdrawalAddressError(!vectorSdk.isValidAddress(event.target.value));
    },
    value: recoverWithdrawalAddress
  }))), React__default.createElement(Button, {
    size: "lg",
    type: "submit",
    disabled: recoverWithdrawalAddressError || recoverTokenAddressError || !recoverTokenAddress || !recoverWithdrawalAddress ? true : false,
    onClick: function onClick() {
      recover(recoverTokenAddress, recoverWithdrawalAddress);
    }
  }, "Recover"))))), React__default.createElement(Footer, null)));
};

var ExistingBalance = function ExistingBalance(props) {
  var isLoad = props.isLoad,
      existingChannelBalance = props.existingChannelBalance,
      senderChainInfo = props.senderChainInfo,
      receiverChainInfo = props.receiverChainInfo,
      receiverAddress = props.receiverAddress,
      options = props.options,
      continueButton = props.continueButton,
      addMoreFunds = props.addMoreFunds;
  return React__default.createElement(React__default.Fragment, null, React__default.createElement(ModalContent, {
    id: "modalContent"
  }, React__default.createElement(Header, {
    title: "Existing Balance",
    options: options
  }), React__default.createElement(ModalBody, null, React__default.createElement(Stack, {
    column: true,
    spacing: 5
  }, React__default.createElement(Stack, {
    column: true,
    spacing: 7
  }, React__default.createElement(Stack, {
    column: true,
    spacing: 3
  }, React__default.createElement(Text, {
    fontSize: "1.5rem",
    fontFamily: "Cooper Hewitt",
    fontWeight: "700",
    lineHeight: "30px",
    flex: "auto"
  }, vectorSdk.truncate(existingChannelBalance, 4), " ", senderChainInfo.assetName), React__default.createElement(Text, {
    fontSize: "14px",
    color: "#333333",
    textTransform: "none"
  }, "Your existing channel already has a balance. Would you like to continue with these funds or add more for transfer?")), React__default.createElement(Stack, {
    column: true,
    spacing: 2
  }, React__default.createElement(Button, {
    size: "lg",
    onClick: continueButton,
    disabled: isLoad
  }, "continue..."), React__default.createElement(Button, {
    size: "lg",
    onClick: addMoreFunds
  }, "Add More Funds"))), React__default.createElement(NetworkBar, {
    senderChainInfo: senderChainInfo,
    receiverChainInfo: receiverChainInfo,
    receiverAddress: receiverAddress
  }))), React__default.createElement(Footer, null)));
};

var RecoverError = function RecoverError(props) {
  var error = props.error,
      options = props.options,
      handleBack = props.handleBack,
      senderChannelAddress = props.senderChannelAddress,
      recipientChannelAddress = props.recipientChannelAddress,
      handleRecoveryButton = props.handleRecoveryButton;

  var _useState = React.useState(false),
      copiedMessage = _useState[0],
      setCopiedMessage = _useState[1];

  return React__default.createElement(React__default.Fragment, null, React__default.createElement(ModalContent, {
    id: "modalContent"
  }, React__default.createElement(Header, {
    title: "Recovery Error",
    warningIcon: true,
    handleBack: handleBack,
    options: options
  }), React__default.createElement(ModalBody, null, React__default.createElement(Stack, {
    column: true,
    spacing: 4
  }, React__default.createElement(Stack, {
    column: true,
    spacing: 2
  }, React__default.createElement(Stack, null, React__default.createElement(Text, {
    fontSize: "0.875rem",
    flex: "auto",
    noOfLines: 3,
    color: "crimson",
    lineHeight: "24px"
  }, error.message), React__default.createElement(IconButton, {
    "aria-label": "Clipboard",
    onClick: function onClick() {
      var message = "senderChannelAddress: " + senderChannelAddress + ", recipientChannelAddress: " + recipientChannelAddress + ", error: " + error.message;
      console.log("Copying: " + message);
      navigator.clipboard.writeText(message);
      setCopiedMessage(true);
      setTimeout(function () {
        return setCopiedMessage(false);
      }, 5000);
    }
  }, React__default.createElement(IconBox, {
    width: "1.5rem"
  }, !copiedMessage ? React__default.createElement(CopyIcon, null) : React__default.createElement(CheckCircleIcon, null)))), React__default.createElement(Box, null, React__default.createElement(Text, {
    fontSize: "0.875rem",
    lineHeight: "24px",
    textTransform: "initial"
  }, "An error occurred during the Recovery. Do not worry, funds are safe."), React__default.createElement(Text, {
    fontSize: "0.875rem",
    lineHeight: "24px",
    textTransform: "initial"
  }, "Support help can be found on our", " ", React__default.createElement(Link, {
    href: "https://support.connext.network",
    target: "_blank",
    color: "green"
  }, "Support Portal"), " "))), React__default.createElement(Stack, {
    column: true,
    spacing: 2
  }, React__default.createElement(Button, {
    size: "lg",
    onClick: handleRecoveryButton
  }, "Recover Funds")))), React__default.createElement(Footer, null)));
};

var RecoverSuccess = function RecoverSuccess(props) {
  var amount = props.amount,
      transactionId = props.transactionId,
      senderChainInfo = props.senderChainInfo,
      onClose = props.onClose,
      options = props.options;
  return React__default.createElement(React__default.Fragment, null, React__default.createElement(ModalContent, {
    id: "modalContent"
  }, React__default.createElement(Header, {
    title: "Recover Success",
    successIcon: true,
    options: options,
    onClose: onClose
  }), React__default.createElement(ModalBody, null, React__default.createElement(Stack, {
    column: true,
    spacing: 7
  }, React__default.createElement(Box, null, React__default.createElement(Stack, {
    column: true,
    spacing: 2
  }, React__default.createElement(Stack, null, React__default.createElement(Text, {
    fontSize: "1.5rem",
    fontFamily: "Cooper Hewitt",
    fontWeight: "700",
    lineHeight: "30px",
    flex: "auto"
  }, vectorSdk.truncate(amount, 6), " ", senderChainInfo.assetName), React__default.createElement(Button, {
    size: "sm",
    borderRadius: "5px",
    colorScheme: "blue",
    border: "none",
    borderStyle: "none",
    color: "white",
    casing: "uppercase",
    onClick: function onClick() {
      return window.open(vectorSdk.getExplorerLinkForTx(senderChainInfo.chainId, transactionId), "_blank");
    }
  }, "view tx")), React__default.createElement(Box, null, React__default.createElement(Text, {
    fontSize: "1rem"
  }, "Now available on " + senderChainInfo.name + ".")))))), React__default.createElement(Footer, null)));
};

var Post = function Post(props) {
  var pendingStatus = "pending transfer";
  var isRetry = props.isRetry,
      receiverChainInfo = props.receiverChainInfo;
  return React__default.createElement(React__default.Fragment, null, React__default.createElement(Stack, {
    spacing: 1
  }, React__default.createElement(Text, {
    fontSize: "1rem",
    fontFamily: "Cooper Hewitt",
    fontWeight: "700",
    lineHeight: "30px",
    flex: "auto"
  }, isRetry ? pendingStatus : props.transactionHash.slice(0, pendingStatus.length - 2), "..."), React__default.createElement(Text, {
    fontSize: "1rem",
    fontFamily: "Cooper Hewitt",
    fontWeight: "700",
    lineHeight: "30px",
    flex: "auto"
  }, vectorSdk.truncate(units.formatUnits(props.amount, receiverChainInfo.assetDecimals), 5), " ", props.withdrawAssetName), React__default.createElement(Button, {
    size: "sm",
    borderRadius: "5px",
    colorScheme: "blue",
    border: "none",
    borderStyle: "none",
    color: "white",
    casing: "uppercase",
    onClick: function onClick() {
      return isRetry ? {} : window.open(vectorSdk.getExplorerLinkForTx(props.withdrawChainId, props.transactionHash), "_blank");
    }
  }, isRetry ? "NA " : "View Tx")));
};

var History = function History(props) {
  var _connextSdk$recipient;

  var options = props.options,
      connextSdk = props.connextSdk;

  var _useState = React.useState([]),
      record = _useState[0],
      setRecord = _useState[1];

  var _useState2 = React.useState(),
      selectValue = _useState2[0],
      setSelectValue = _useState2[1];

  var _useState3 = React.useState(),
      errorMessage = _useState3[0],
      setErrorMessage = _useState3[1];

  var bobIdentifier = connextSdk == null ? void 0 : (_connextSdk$recipient = connextSdk.recipientChainChannel) == null ? void 0 : _connextSdk$recipient.bobIdentifier;
  var recipientChainChannelAddress = connextSdk == null ? void 0 : connextSdk.recipientChainChannelAddress;
  var receiverChainInfo = connextSdk == null ? void 0 : connextSdk.recipientChain;

  var retryWithdraw = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee(transferId) {
      var res;
      return runtime_1.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              setErrorMessage(undefined);
              _context.prev = 1;
              _context.next = 4;
              return connextSdk.retryWithdraw(transferId);

            case 4:
              res = _context.sent;
              console.log(res);
              _context.next = 13;
              break;

            case 8:
              _context.prev = 8;
              _context.t0 = _context["catch"](1);
              console.log(_context.t0);
              setErrorMessage(_context.t0.message);
              return _context.abrupt("return");

            case 13:
              getRecord();

            case 14:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[1, 8]]);
    }));

    return function retryWithdraw(_x) {
      return _ref.apply(this, arguments);
    };
  }();

  var getRecord = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee3(_startDate) {
      var defaultEndDate, startDate, res, transfers;
      return runtime_1.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              setRecord([]);
              defaultEndDate = new Date();
              console.log(defaultEndDate);
              startDate = new Date(defaultEndDate.getTime() - 86400000 * (_startDate != null ? _startDate : 1)); // 1 Day = 86400_000 ms

              console.log(startDate);
              console.log(bobIdentifier, recipientChainChannelAddress);
              _context3.next = 8;
              return connextSdk == null ? void 0 : connextSdk.browserNode.getTransfers({
                publicIdentifier: bobIdentifier,
                active: false,
                channelAddress: recipientChainChannelAddress,
                startDate: startDate,
                endDate: defaultEndDate
              });

            case 8:
              res = _context3.sent;

              if (!res.isError) {
                _context3.next = 12;
                break;
              }

              console.log(res.getError());
              return _context3.abrupt("return");

            case 12:
              transfers = res.getValue();
              transfers.forEach( /*#__PURE__*/function () {
                var _ref3 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee2(s) {
                  var ret, state, _chain$assetId$state$, _chain$assetId$state$2, _state$transactionHas, chain, assetName, isRetry, _record;

                  return runtime_1.wrap(function _callee2$(_context2) {
                    while (1) {
                      switch (_context2.prev = _context2.next) {
                        case 0:
                          if (!(s.transferId && s.channelAddress === recipientChainChannelAddress)) {
                            _context2.next = 16;
                            break;
                          }

                          _context2.next = 3;
                          return connextSdk == null ? void 0 : connextSdk.browserNode.getWithdrawalCommitment({
                            transferId: s.transferId
                          });

                        case 3:
                          ret = _context2.sent;
                          state = ret.getValue();

                          if (!(state && state.recipient && state.alice !== state.recipient)) {
                            _context2.next = 16;
                            break;
                          }

                          console.log("state:", state);
                          console.log("transfer:", s);
                          _context2.next = 10;
                          return vectorSdk.getChainInfo(s.chainId);

                        case 10:
                          chain = _context2.sent;
                          assetName = (_chain$assetId$state$ = (_chain$assetId$state$2 = chain.assetId[state.assetId]) == null ? void 0 : _chain$assetId$state$2.symbol) != null ? _chain$assetId$state$ : "Token";
                          isRetry = false;

                          if (!state.transactionHash) {
                            isRetry = true;
                          }

                          _record = {
                            isRetry: isRetry,
                            transactionHash: (_state$transactionHas = state.transactionHash) != null ? _state$transactionHas : undefined,
                            withdrawChainId: s.chainId,
                            withdrawAssetName: assetName,
                            amount: state.amount,
                            fee: s.transferState.fee,
                            transferId: s.transferId
                          };
                          setRecord(function (rec) {
                            return rec.concat(_record);
                          });

                        case 16:
                        case "end":
                          return _context2.stop();
                      }
                    }
                  }, _callee2);
                }));

                return function (_x3) {
                  return _ref3.apply(this, arguments);
                };
              }());

            case 14:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function getRecord(_x2) {
      return _ref2.apply(this, arguments);
    };
  }();

  var resetState = function resetState() {
    setErrorMessage(undefined);
  };

  React.useEffect(function () {
    resetState();
    getRecord(); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);

  var handleChange = function handleChange(event) {
    console.log(event);
    setSelectValue(event);
    getRecord(event.value);
  };

  var TimeOptions = [{
    value: 1,
    label: "Last 24 Hours"
  }, {
    value: 3,
    label: "3 Days"
  }, {
    value: 15,
    label: "15 Days"
  }, {
    value: 30,
    label: "30 Days"
  }, {
    value: 60,
    label: "60 Days"
  }, {
    value: 365,
    label: "1 Year"
  }];
  return React__default.createElement(React__default.Fragment, null, React__default.createElement(ModalContent, {
    id: "modalContent"
  }, React__default.createElement(Header, {
    title: "Transaction History",
    options: options
  }), React__default.createElement(ModalBody, null, React__default.createElement(Stack, {
    column: true,
    spacing: 2
  }, React__default.createElement(Box, null, React__default.createElement(Select, {
    value: selectValue,
    options: TimeOptions,
    onChange: handleChange,
    placeholder: "Select Time Period",
    defaultValue: TimeOptions[0],
    fullWidth: true
  })), errorMessage && React__default.createElement(Text, {
    flex: "auto",
    fontSize: "0.75rem",
    textAlign: "center"
  }, errorMessage), React__default.createElement(Stack, {
    column: true,
    spacing: 3
  }, React__default.createElement(Stack, {
    colorScheme: "antiquewhite"
  }, React__default.createElement(Text, {
    padding: "0 0 0 1rem",
    textAlign: "start",
    fontSize: "1rem",
    fontFamily: "Cooper Hewitt",
    fontWeight: "700",
    lineHeight: "30px",
    flex: "auto"
  }, "Txn Status"), React__default.createElement(Text, {
    textAlign: "center",
    fontSize: "1rem",
    fontFamily: "Cooper Hewitt",
    fontWeight: "700",
    lineHeight: "30px",
    flex: "auto"
  }, "Value"), React__default.createElement(Text, {
    padding: "0 1rem 0 0",
    textAlign: "end",
    fontSize: "1rem",
    fontFamily: "Cooper Hewitt",
    fontWeight: "700",
    lineHeight: "30px",
    flex: "auto"
  }, "Visit")), React__default.createElement(Stack, {
    column: true,
    spacing: 1
  }, record.map(function (c) {
    return React__default.createElement(Post, {
      isRetry: c.isRetry,
      receiverChainInfo: receiverChainInfo,
      transactionHash: c.transactionHash,
      withdrawChainId: c.withdrawChainId,
      withdrawAssetName: c.withdrawAssetName,
      amount: c.amount,
      fee: c.fee,
      transferId: c.transferId,
      retryWithdraw: retryWithdraw
    });
  }))))), React__default.createElement(Footer, null)));
};

var UserInfo = function UserInfo(props) {
  var _connextSdk$senderCha, _connextSdk$senderCha2, _connextSdk$senderCha3, _connextSdk$recipient, _connextSdk$senderCha4, _connextSdk$senderCha5;

  var options = props.options,
      connextSdk = props.connextSdk;

  var _useState = React.useState(false),
      copiedMessage = _useState[0],
      setCopiedMessage = _useState[1];

  var info = {
    alice: connextSdk == null ? void 0 : (_connextSdk$senderCha = connextSdk.senderChainChannel) == null ? void 0 : _connextSdk$senderCha.aliceIdentifier,
    bob: connextSdk == null ? void 0 : (_connextSdk$senderCha2 = connextSdk.senderChainChannel) == null ? void 0 : _connextSdk$senderCha2.bobIdentifier,
    senderChain: connextSdk == null ? void 0 : (_connextSdk$senderCha3 = connextSdk.senderChain) == null ? void 0 : _connextSdk$senderCha3.name,
    senderChainChannelAddress: connextSdk.senderChainChannelAddress,
    recipientChain: connextSdk == null ? void 0 : (_connextSdk$recipient = connextSdk.recipientChain) == null ? void 0 : _connextSdk$recipient.name,
    recipientChainChannelAddress: connextSdk == null ? void 0 : connextSdk.recipientChainChannelAddress,
    senderChannelState: "",
    recipientChannelState: ""
  };
  return React__default.createElement(React__default.Fragment, null, React__default.createElement(ModalContent, {
    id: "modalContent"
  }, React__default.createElement(Header, {
    title: "User Info",
    options: options
  }), React__default.createElement(ModalBody, null, React__default.createElement(Stack, {
    column: true,
    spacing: 1
  }, React__default.createElement(Stack, {
    justifyContent: "space-between",
    colorScheme: "antiquewhite"
  }, React__default.createElement(Text, {
    fontSize: "1.25rem",
    textTransform: "capitalize",
    style: {
      alignSelf: "center"
    }
  }, "Share Info with Team"), React__default.createElement(IconButton, {
    "aria-label": "Clipboard",
    onClick: function () {
      var _onClick = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee() {
        var _JSON$stringify, _JSON$stringify2;

        var senderChannel, recipientChannel, message;
        return runtime_1.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return connextSdk == null ? void 0 : connextSdk.browserNode.getStateChannel({
                  channelAddress: info.senderChainChannelAddress
                });

              case 2:
                senderChannel = _context.sent;
                _context.next = 5;
                return connextSdk == null ? void 0 : connextSdk.browserNode.getStateChannel({
                  channelAddress: info.recipientChainChannelAddress
                });

              case 5:
                recipientChannel = _context.sent;
                info.senderChannelState = (_JSON$stringify = JSON.stringify(senderChannel == null ? void 0 : senderChannel.getValue())) != null ? _JSON$stringify : "";
                info.recipientChannelState = (_JSON$stringify2 = JSON.stringify(recipientChannel == null ? void 0 : recipientChannel.getValue())) != null ? _JSON$stringify2 : "";
                message = JSON.stringify(info);
                console.log("Copying: " + message);
                navigator.clipboard.writeText(message);
                setCopiedMessage(true);
                setTimeout(function () {
                  return setCopiedMessage(false);
                }, 5000);

              case 13:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function onClick() {
        return _onClick.apply(this, arguments);
      }

      return onClick;
    }()
  }, React__default.createElement(IconBox, {
    width: "1.5rem"
  }, !copiedMessage ? React__default.createElement(CopyIcon, null) : React__default.createElement(CheckCircleIcon, null)))), React__default.createElement(Stack, {
    column: true,
    spacing: 2
  }, React__default.createElement(Stack, {
    column: true,
    spacing: 1
  }, React__default.createElement(Text, {
    fontSize: "1rem",
    textTransform: "capitalize"
  }, "Alice"), React__default.createElement(InputGroup, null, React__default.createElement(Input, {
    id: "address",
    name: "address",
    value: connextSdk == null ? void 0 : (_connextSdk$senderCha4 = connextSdk.senderChainChannel) == null ? void 0 : _connextSdk$senderCha4.aliceIdentifier,
    inputMode: "search",
    title: "receiver Address",
    // styled
    body: "md",
    fontSize: "13px",
    // misc
    readOnly: true
  }))), React__default.createElement(Stack, {
    column: true,
    spacing: 1
  }, React__default.createElement(Text, {
    fontSize: "1rem",
    textTransform: "capitalize"
  }, "Bob"), React__default.createElement(InputGroup, null, React__default.createElement(Input, {
    id: "address",
    name: "address",
    value: connextSdk == null ? void 0 : (_connextSdk$senderCha5 = connextSdk.senderChainChannel) == null ? void 0 : _connextSdk$senderCha5.bobIdentifier,
    inputMode: "search",
    title: "receiver Address",
    // styled
    body: "md",
    fontSize: "13px",
    // misc
    readOnly: true
  }))), React__default.createElement(Stack, {
    column: true,
    spacing: 1
  }, React__default.createElement(Text, {
    fontSize: "1rem",
    textTransform: "capitalize"
  }, info.senderChain, " Channel Address"), React__default.createElement(InputGroup, null, React__default.createElement(Input, {
    id: "address",
    name: "address",
    value: connextSdk == null ? void 0 : connextSdk.senderChainChannelAddress,
    inputMode: "search",
    title: "receiver Address",
    // styled
    body: "md",
    fontSize: "13px",
    // misc
    readOnly: true
  }))), React__default.createElement(Stack, {
    column: true,
    spacing: 1
  }, React__default.createElement(Text, {
    fontSize: "1rem",
    textTransform: "capitalize"
  }, info.recipientChain, " Channel Address"), React__default.createElement(InputGroup, null, React__default.createElement(Input, {
    id: "address",
    name: "address",
    value: connextSdk == null ? void 0 : connextSdk.recipientChainChannelAddress,
    inputMode: "search",
    title: "receiver Address",
    // styled
    body: "md",
    fontSize: "13px",
    // misc
    readOnly: true
  })))))), React__default.createElement(Footer, null)));
};

var _templateObject$e, _templateObject2$4;

var ConnextModal = function ConnextModal(_ref) {
  var showModal = _ref.showModal,
      routerPublicIdentifier = _ref.routerPublicIdentifier,
      depositChainProvider = _ref.depositChainProvider,
      _depositAssetId = _ref.depositAssetId,
      _depositChainId = _ref.depositChainId,
      withdrawChainProvider = _ref.withdrawChainProvider,
      _withdrawAssetId = _ref.withdrawAssetId,
      _withdrawChainId = _ref.withdrawChainId,
      withdrawalAddress = _ref.withdrawalAddress,
      vaultName = _ref.vaultName,
      withdrawalRecipient = _ref.withdrawalRecipient,
      _transferAmount = _ref.transferAmount,
      _injectedProvider = _ref.injectedProvider,
      _loginProvider = _ref.loginProvider,
      iframeSrcOverride = _ref.iframeSrcOverride,
      withdrawCallTo = _ref.withdrawCallTo,
      withdrawCallData = _ref.withdrawCallData,
      generateCallData = _ref.generateCallData,
      onClose = _ref.onClose,
      onReady = _ref.onReady,
      onSwap = _ref.onSwap,
      onDepositTxCreated = _ref.onDepositTxCreated,
      onFinished = _ref.onFinished;
  var depositAssetId = address.getAddress(_depositAssetId);
  var withdrawAssetId = address.getAddress(_withdrawAssetId);

  var _useState = React.useState(),
      webProvider = _useState[0],
      setWebProvider = _useState[1];

  var loginProvider = !!_loginProvider ? new providers.Web3Provider(_loginProvider) : undefined;

  var _useState2 = React.useState(),
      transferAmountUi = _useState2[0],
      setTransferAmountUi = _useState2[1];

  var _useState3 = React.useState(),
      receivedAmountUi = _useState3[0],
      setReceivedAmountUi = _useState3[1];

  var _useState4 = React.useState(),
      transferFeeUi = _useState4[0],
      setTransferFeeUi = _useState4[1];

  var _useState5 = React.useState(),
      swapRate = _useState5[0],
      setSwapRate = _useState5[1];

  var _useState6 = React.useState(),
      existingChannelBalanceUi = _useState6[0],
      setExistingChannelBalanceUi = _useState6[1];

  var _useState7 = React.useState(),
      successWithdrawalAmount = _useState7[0],
      setSuccessWithdrawalAmount = _useState7[1];

  var _useState8 = React.useState(),
      senderChain = _useState8[0],
      setSenderChain = _useState8[1];

  var _useState9 = React.useState(),
      receiverChain = _useState9[0],
      setReceiverChain = _useState9[1];

  var _useState10 = React.useState(),
      userAddress = _useState10[0],
      setUserAddress = _useState10[1];

  var _useState11 = React.useState(),
      userBalance = _useState11[0],
      setUserBalance = _useState11[1];

  var _useState12 = React.useState(),
      withdrawTx = _useState12[0],
      setWithdrawTx = _useState12[1];

  var _useState13 = React.useState(),
      error = _useState13[0],
      setError = _useState13[1];

  var _useState14 = React.useState(),
      amountError = _useState14[0],
      setAmountError = _useState14[1];

  var _useState15 = React.useState(),
      connextSdk = _useState15[0],
      setConnextSdk = _useState15[1];

  var _useState16 = React.useState(),
      listener = _useState16[0],
      setListener = _useState16[1];

  var _useState17 = React.useState(SCREEN_STATES.LOADING),
      screenState = _useState17[0],
      setScreenState = _useState17[1];

  var _useState18 = React.useState(),
      lastScreenState = _useState18[0],
      setLastScreenState = _useState18[1];

  var _useState19 = React.useState(),
      transferQuote = _useState19[0],
      setTransferQuote = _useState19[1];

  var _useState20 = React.useState(),
      title = _useState20[0],
      setTitle = _useState20[1];

  var _useState21 = React.useState(),
      message = _useState21[0],
      setMessage = _useState21[1];

  var _useState22 = React.useState(false),
      isLoad = _useState22[0],
      setIsLoad = _useState22[1];

  var _useState23 = React.useState(false),
      showTimer = _useState23[0],
      setShowTimer = _useState23[1]; // temp


  var _useState24 = React.useState(false),
      inputReadOnly = _useState24[0],
      setInputReadOnly = _useState24[1];

  var onSuccess = function onSuccess(txHash, amountUi, amountBn) {
    console.log(txHash, amountUi, amountBn);
    setWithdrawTx(txHash);
    setSuccessWithdrawalAmount(amountUi);

    if (onFinished) {
      onFinished(txHash, amountBn.toString());
    }

    if (screenState === SCREEN_STATES.RECOVER) {
      handleScreen({
        state: SCREEN_STATES.RECOVER_SUCCESS
      });
    } else {
      handleScreen({
        state: SCREEN_STATES.SUCCESS
      });
    }
  };

  var depositListenerAndTransfer = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee2() {
      var initialDeposits, depositListener;
      return runtime_1.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              handleScreen({
                state: SCREEN_STATES.LISTENER
              });
              setShowTimer(true);
              _context2.prev = 2;
              _context2.next = 5;
              return vectorSdk.getTotalDepositsBob(connextSdk == null ? void 0 : connextSdk.senderChainChannelAddress, senderChain.assetId, senderChain.rpcProvider);

            case 5:
              initialDeposits = _context2.sent;
              _context2.next = 12;
              break;

            case 8:
              _context2.prev = 8;
              _context2.t0 = _context2["catch"](2);
              handleScreen({
                state: ERROR_STATES.ERROR_TRANSFER,
                error: _context2.t0,
                message: "Error getting total deposits"
              });
              return _context2.abrupt("return");

            case 12:
              console.log("Starting balance on " + (senderChain == null ? void 0 : senderChain.chainId) + " for " + connextSdk.senderChainChannelAddress + " of asset " + depositAssetId + ": " + initialDeposits.toString());
              depositListener = setInterval( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee() {
                var updatedDeposits;
                return runtime_1.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.prev = 0;
                        _context.next = 3;
                        return vectorSdk.getTotalDepositsBob(connextSdk.senderChainChannelAddress, depositAssetId, senderChain.rpcProvider);

                      case 3:
                        updatedDeposits = _context.sent;
                        _context.next = 10;
                        break;

                      case 6:
                        _context.prev = 6;
                        _context.t0 = _context["catch"](0);
                        console.warn("Error fetching balance: " + _context.t0.message);
                        return _context.abrupt("return");

                      case 10:
                        console.log("Updated balance on " + (senderChain == null ? void 0 : senderChain.chainId) + " for " + connextSdk.senderChainChannelAddress + " of asset " + depositAssetId + ": " + updatedDeposits.toString());

                        if (updatedDeposits.lt(initialDeposits)) {
                          initialDeposits = updatedDeposits;
                        }

                        if (!updatedDeposits.gt(initialDeposits)) {
                          _context.next = 17;
                          break;
                        }

                        clearInterval(depositListener);
                        setShowTimer(false);
                        _context.next = 17;
                        return handleSwap();

                      case 17:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee, null, [[0, 6]]);
              })), 5000);
              setListener(depositListener);

            case 15:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[2, 8]]);
    }));

    return function depositListenerAndTransfer() {
      return _ref2.apply(this, arguments);
    };
  }();

  var handleSwapCheck = /*#__PURE__*/function () {
    var _ref4 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee3(_input, receiveExactAmount) {
      var input, inputBn, transferAmountBn, existingBalanceBn, transferAmount, res, _res$totalFee, tA, rA, _swapRate, userBalanceBn, err, _message;

      return runtime_1.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              input = _input ? _input.trim() : undefined;
              setReceivedAmountUi(undefined);
              setSwapRate(undefined);
              setTransferFeeUi(undefined);
              receiveExactAmount ? setReceivedAmountUi(input) : setTransferAmountUi(input);

              if (input) {
                _context3.next = 8;
                break;
              }

              setAmountError(undefined);
              return _context3.abrupt("return");

            case 8:
              inputBn = bignumber.BigNumber.from(units.parseUnits(input, senderChain == null ? void 0 : senderChain.assetDecimals));
              transferAmountBn = inputBn;

              if (existingChannelBalanceUi) {
                existingBalanceBn = bignumber.BigNumber.from(units.parseUnits(existingChannelBalanceUi, senderChain == null ? void 0 : senderChain.assetDecimals));
                transferAmountBn = transferAmountBn.add(existingBalanceBn);
              }

              transferAmount = units.formatUnits(transferAmountBn.toString(), senderChain == null ? void 0 : senderChain.assetDecimals);
              _context3.prev = 12;
              _context3.next = 15;
              return connextSdk.estimateFees({
                transferAmount: transferAmount,
                isRecipientAssetInput: receiveExactAmount
              });

            case 15:
              res = _context3.sent;
              console.log(res);
              setAmountError(res.error);
              setTransferQuote(res.transferQuote);
              receiveExactAmount ? setTransferAmountUi(res.senderAmount) : setReceivedAmountUi(vectorSdk.truncate(res.recipientAmount, 5));
              if (res.totalFee) setTransferFeeUi(res.totalFee);

              if (res.recipientAmount) {
                tA = parseFloat(transferAmount) - parseFloat((_res$totalFee = res.totalFee) != null ? _res$totalFee : "0");
                rA = parseFloat(res.recipientAmount);
                _swapRate = tA / rA;
                setSwapRate(_swapRate.toString());
              }

              if (userBalance && !res.error) {
                userBalanceBn = bignumber.BigNumber.from(units.parseUnits(userBalance, senderChain == null ? void 0 : senderChain.assetDecimals));

                if (inputBn.gt(userBalanceBn)) {
                  err = "Transfer amount exceeds user balance";
                  setAmountError(err);
                }
              }

              return _context3.abrupt("return", res.transferQuote);

            case 26:
              _context3.prev = 26;
              _context3.t0 = _context3["catch"](12);
              _message = "Error Estimating Fees";
              console.log(_message, _context3.t0);
              setAmountError(_context3.t0.message);
              return _context3.abrupt("return");

            case 32:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, null, [[12, 26]]);
    }));

    return function handleSwapCheck(_x, _x2) {
      return _ref4.apply(this, arguments);
    };
  }();

  var handleSwapRequest = /*#__PURE__*/function () {
    var _ref5 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee4() {
      var transferAmountBn;
      return runtime_1.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              setIsLoad(true);
              _context4.prev = 1;
              console.log(receivedAmountUi);
              _context4.next = 5;
              return connextSdk.preTransferCheck(receivedAmountUi);

            case 5:
              _context4.next = 13;
              break;

            case 7:
              _context4.prev = 7;
              _context4.t0 = _context4["catch"](1);
              console.log("Error at preCheck", _context4.t0);
              setIsLoad(false);
              setAmountError(_context4.t0.message);
              return _context4.abrupt("return");

            case 13:
              transferAmountBn = bignumber.BigNumber.from(units.parseUnits(transferAmountUi, senderChain == null ? void 0 : senderChain.assetDecimals));

              if (!(transferAmountBn.isZero() && existingChannelBalanceUi)) {
                _context4.next = 18;
                break;
              }

              setIsLoad(false);
              handleSwap();
              return _context4.abrupt("return");

            case 18:
              if (!onSwap) {
                _context4.next = 35;
                break;
              }

              _context4.prev = 19;
              console.log("Calling onSwap function");
              _context4.next = 23;
              return onSwap(transferAmountBn.toString(), connextSdk == null ? void 0 : connextSdk.browserNode);

            case 23:
              _context4.next = 31;
              break;

            case 25:
              _context4.prev = 25;
              _context4.t1 = _context4["catch"](19);
              console.log("onswap error", _context4.t1);
              setIsLoad(false);
              handleScreen({
                state: ERROR_STATES.ERROR_TRANSFER,
                error: _context4.t1,
                message: "Error calling onSwap"
              });
              return _context4.abrupt("return");

            case 31:
              setIsLoad(false);
              handleSwap();
              _context4.next = 55;
              break;

            case 35:
              if (!webProvider) {
                _context4.next = 52;
                break;
              }

              _context4.prev = 36;
              _context4.next = 39;
              return connextSdk.deposit({
                transferAmount: transferAmountUi,
                webProvider: webProvider,
                preTransferCheck: false,
                onDeposited: onDepositTxCreated
              });

            case 39:
              _context4.next = 48;
              break;

            case 41:
              _context4.prev = 41;
              _context4.t2 = _context4["catch"](36);
              setIsLoad(false);

              if (!_context4.t2.message.includes("User denied transaction signature")) {
                _context4.next = 46;
                break;
              }

              return _context4.abrupt("return");

            case 46:
              handleScreen({
                state: ERROR_STATES.ERROR_TRANSFER,
                error: _context4.t2,
                message: "Error in injected provider deposit: "
              });
              return _context4.abrupt("return");

            case 48:
              setIsLoad(false);
              handleSwap();
              _context4.next = 55;
              break;

            case 52:
              console.log("Starting block listener"); // display QR

              setIsLoad(false);
              depositListenerAndTransfer();

            case 55:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, null, [[1, 7], [19, 25], [36, 41]]);
    }));

    return function handleSwapRequest() {
      return _ref5.apply(this, arguments);
    };
  }();

  var handleSwap = /*#__PURE__*/function () {
    var _ref6 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee5(pTransferQuote) {
      var quote, _message2, _message3;

      return runtime_1.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              handleScreen({
                state: SCREEN_STATES.STATUS,
                title: "transferring",
                message: "Transferring " + (senderChain == null ? void 0 : senderChain.assetName) + ". This step can take some time if the chain is congested"
              });
              console.log(pTransferQuote);
              quote = pTransferQuote != null ? pTransferQuote : transferQuote;
              _context5.prev = 3;
              _context5.next = 6;
              return connextSdk.transfer({
                transferQuote: quote
              });

            case 6:
              _context5.next = 14;
              break;

            case 8:
              _context5.prev = 8;
              _context5.t0 = _context5["catch"](3);
              _message2 = "Error at Transfer";
              console.log(_context5.t0, _message2);
              handleScreen({
                state: ERROR_STATES.ERROR_TRANSFER,
                error: _context5.t0,
                message: _message2
              });
              return _context5.abrupt("return");

            case 14:
              handleScreen({
                state: SCREEN_STATES.STATUS,
                title: "withdrawing",
                message: "withdrawing " + (senderChain == null ? void 0 : senderChain.assetName) + " to " + (receiverChain == null ? void 0 : receiverChain.name) + ". This step can take some time if the chain is congested"
              });
              _context5.prev = 15;
              _context5.next = 18;
              return connextSdk.withdraw({
                recipientAddress: withdrawalAddress,
                onFinished: onSuccess,
                withdrawalCallTo: withdrawCallTo,
                withdrawalCallData: withdrawCallData,
                generateCallData: generateCallData
              });

            case 18:
              _context5.next = 26;
              break;

            case 20:
              _context5.prev = 20;
              _context5.t1 = _context5["catch"](15);
              _message3 = "Error at withdraw";
              console.log(_context5.t1, _message3);
              handleScreen({
                state: ERROR_STATES.ERROR_TRANSFER,
                error: _context5.t1,
                message: _message3
              });
              return _context5.abrupt("return");

            case 26:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, null, [[3, 8], [15, 20]]);
    }));

    return function handleSwap(_x3) {
      return _ref6.apply(this, arguments);
    };
  }();

  var stateReset = function stateReset() {
    handleScreen({
      state: SCREEN_STATES.LOADING
    });
    setWebProvider(undefined);
    setInputReadOnly(false);
    setIsLoad(false);
    setTransferFeeUi(undefined);
    setExistingChannelBalanceUi("");
    setReceivedAmountUi("");
    setSwapRate(undefined);
    setTransferQuote(undefined);
    setUserBalance(undefined);
    setUserAddress(undefined);
    setError(undefined);
  };

  var setup = /*#__PURE__*/function () {
    var _ref7 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee6() {
      var injectedProvider, senderChainInfo, _message4, receiverChainInfo, _message5, _message6, network, _message7, defaultMetmaskNetworks, _state, signer, address, _userBalance, _message8, connextSdk, _error, _message9, response, _message10, offChainDepositAssetBalance, offChainWithdrawAssetBalance, _senderChainInfo, existingBalance, _message11;

      return runtime_1.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              // set web provider
              setMessage("getting chains info...");
              injectedProvider = !!_injectedProvider ? new providers.Web3Provider(_injectedProvider) : undefined;
              setWebProvider(injectedProvider);

              if (vectorSdk.isValidAddress(withdrawalAddress)) {
                _context6.next = 7;
                break;
              }

              console.log("Invalid receiver address", withdrawalAddress);
              handleScreen({
                state: ERROR_STATES.ERROR_SETUP,
                error: new Error("Invalid receiver address")
              });
              return _context6.abrupt("return");

            case 7:
              _context6.prev = 7;
              _context6.next = 10;
              return vectorSdk.getChain(_depositChainId, depositChainProvider, depositAssetId);

            case 10:
              senderChainInfo = _context6.sent;
              setSenderChain(senderChainInfo);
              _context6.next = 20;
              break;

            case 14:
              _context6.prev = 14;
              _context6.t0 = _context6["catch"](7);
              _message4 = "Failed to fetch sender chain info";
              console.log(_context6.t0, _message4);
              handleScreen({
                state: ERROR_STATES.ERROR_SETUP,
                error: _context6.t0,
                message: _message4
              });
              return _context6.abrupt("return");

            case 20:
              _context6.prev = 20;
              _context6.next = 23;
              return vectorSdk.getChain(_withdrawChainId, withdrawChainProvider, withdrawAssetId);

            case 23:
              receiverChainInfo = _context6.sent;
              setReceiverChain(receiverChainInfo);
              _context6.next = 33;
              break;

            case 27:
              _context6.prev = 27;
              _context6.t1 = _context6["catch"](20);
              _message5 = "Failed to fetch receiver chain info";
              console.log(_context6.t1, _message5);
              handleScreen({
                state: ERROR_STATES.ERROR_SETUP,
                error: _context6.t1,
                message: _message5
              });
              return _context6.abrupt("return");

            case 33:
              if (!_transferAmount) {
                _context6.next = 45;
                break;
              }

              _context6.prev = 34;
              setInputReadOnly(true);
              setTransferAmountUi(_transferAmount);
              _context6.next = 45;
              break;

            case 39:
              _context6.prev = 39;
              _context6.t2 = _context6["catch"](34);
              _message6 = "Error with transferAmount param";
              console.log(_context6.t2, _message6);
              handleScreen({
                state: ERROR_STATES.ERROR_SETUP,
                error: _context6.t2,
                message: _message6
              });
              return _context6.abrupt("return");

            case 45:
              if (!injectedProvider) {
                _context6.next = 74;
                break;
              }

              _context6.prev = 46;
              _context6.next = 49;
              return injectedProvider.getNetwork();

            case 49:
              network = _context6.sent;
              console.log(network);

              if (!(senderChainInfo.chainId !== network.chainId)) {
                _context6.next = 57;
                break;
              }

              _message7 = "Please connect your wallet to the " + senderChainInfo.name + " : " + senderChainInfo.chainId + " network";
              defaultMetmaskNetworks = [1, 3, 4, 5, 42];
              _state = // @ts-ignore
              ethereum && // @ts-ignore
              ethereum.isMetaMask && !defaultMetmaskNetworks.includes(senderChainInfo.chainId) ? ERROR_STATES.ERROR_NETWORK : ERROR_STATES.ERROR_SETUP;
              handleScreen({
                state: _state,
                error: new Error(_message7),
                title: "Switch Network",
                message: _message7
              });
              return _context6.abrupt("return");

            case 57:
              signer = injectedProvider.getSigner();
              _context6.next = 60;
              return signer.getAddress();

            case 60:
              address = _context6.sent;
              setUserAddress(address);
              _context6.next = 64;
              return vectorSdk.getUserBalance(injectedProvider, senderChainInfo.assetId, senderChainInfo.assetDecimals);

            case 64:
              _userBalance = _context6.sent;
              setUserBalance(_userBalance);
              _context6.next = 74;
              break;

            case 68:
              _context6.prev = 68;
              _context6.t3 = _context6["catch"](46);
              _message8 = _context6.t3.message;
              console.log(_context6.t3, _message8);
              handleScreen({
                state: ERROR_STATES.ERROR_SETUP,
                error: _context6.t3,
                message: _message8
              });
              return _context6.abrupt("return");

            case 74:
              setMessage("Setting up channels...");
              connextSdk = new vectorSdk.ConnextSdk();
              _context6.prev = 76;
              _context6.next = 79;
              return connextSdk.setup({
                routerPublicIdentifier: routerPublicIdentifier,
                loginProvider: loginProvider,
                senderChainProvider: depositChainProvider,
                senderAssetId: depositAssetId,
                recipientChainProvider: withdrawChainProvider,
                recipientAssetId: withdrawAssetId,
                senderChainId: _depositChainId,
                recipientChainId: _withdrawChainId,
                iframeSrcOverride: iframeSrcOverride
              });

            case 79:
              setConnextSdk(connextSdk);
              _context6.next = 92;
              break;

            case 82:
              _context6.prev = 82;
              _context6.t4 = _context6["catch"](76);
              _error = _context6.t4;

              if (_context6.t4.message.includes("localStorage not available in this window") || _context6.t4.message.includes("Failed to read the 'localStorage'") || _context6.t4.message.includes("The user denied permission to access the database") || _context6.t4.message.includes("mutation was performed")) {
                alert("Please disable shields or ad blockers or allow third party cookies in your browser and try again. Connext requires cross-site cookies to store your channel states.");
                _error = new Error("Please disable shields or ad blockers or allow third party cookies in your browser and try again. Connext requires cross-site cookies to store your channel states.");
              }

              if (_context6.t4.message.includes("Ethereum is not defined") || _context6.t4.message.includes("Internal JSON-RPC Error")) {
                _error = new Error("An error occurred connecting to your wallet's RPC. This is a known bug with mobile wallets. Please switch to desktop or refresh.");
              }

              if (_context6.t4.message.includes("Authentication Timeout")) {
                alert("An temporary issue occurred with your network connection. Please refresh and try again.");
                _error = new Error("An temporary issues occurred with your network connection. Please refresh and try again.");
              }

              _message9 = "Error initalizing";
              console.log(_error, _message9);
              handleScreen({
                state: ERROR_STATES.ERROR_SETUP,
                error: _error,
                message: _context6.t4.message
              });
              return _context6.abrupt("return");

            case 92:
              if (onReady) {
                onReady({
                  depositChannelAddress: connextSdk.senderChainChannelAddress,
                  withdrawChannelAddress: connextSdk.recipientChainChannelAddress
                });
              }

              setMessage("Looking for pending Transfers...");
              _context6.prev = 94;
              _context6.next = 97;
              return connextSdk.checkPendingTransfer();

            case 97:
              response = _context6.sent;
              _context6.next = 106;
              break;

            case 100:
              _context6.prev = 100;
              _context6.t5 = _context6["catch"](94);
              _message10 = "Failed at Pending Tranfer Check";
              console.log(_context6.t5, _message10);
              handleScreen({
                state: ERROR_STATES.ERROR_SETUP,
                error: _context6.t5,
                message: _message10
              });
              return _context6.abrupt("return");

            case 106:
              console.log(response);
              offChainDepositAssetBalance = response.offChainSenderChainAssetBalanceBn;
              offChainWithdrawAssetBalance = response.offChainRecipientChainAssetBalanceBn;

              if (offChainDepositAssetBalance.gt(0) && offChainWithdrawAssetBalance.gt(0)) {
                console.warn("Balance exists in both channels, transferring first, then withdrawing");
              } // if offChainDepositAssetBalance > 0


              if (!offChainDepositAssetBalance.gt(0)) {
                _context6.next = 116;
                break;
              }

              existingBalance = units.formatUnits(offChainDepositAssetBalance.toString(), (_senderChainInfo = senderChainInfo) == null ? void 0 : _senderChainInfo.assetDecimals);
              setExistingChannelBalanceUi(existingBalance);
              handleScreen({
                state: SCREEN_STATES.EXISTING_BALANCE
              });
              _context6.next = 132;
              break;

            case 116:
              if (!offChainWithdrawAssetBalance.gt(0)) {
                _context6.next = 131;
                break;
              }

              // then go to withdraw screen with transfer amount == balance
              handleScreen({
                state: SCREEN_STATES.STATUS,
                title: "withdrawing",
                message: "withdrawing " + (senderChain == null ? void 0 : senderChain.assetName) + " to " + (receiverChain == null ? void 0 : receiverChain.name) + ". This step can take some time if the chain is congested"
              });
              _context6.prev = 118;
              _context6.next = 121;
              return connextSdk.withdraw({
                recipientAddress: withdrawalAddress,
                onFinished: onSuccess,
                withdrawalCallTo: withdrawCallTo,
                withdrawalCallData: withdrawCallData,
                generateCallData: generateCallData
              });

            case 121:
              _context6.next = 129;
              break;

            case 123:
              _context6.prev = 123;
              _context6.t6 = _context6["catch"](118);
              _message11 = "Error at withdraw";
              console.log(_context6.t6, _message11);
              handleScreen({
                state: ERROR_STATES.ERROR_TRANSFER,
                error: _context6.t6,
                message: _message11
              });
              return _context6.abrupt("return");

            case 129:
              _context6.next = 132;
              break;

            case 131:
              handleScreen({
                state: SCREEN_STATES.SWAP
              });

            case 132:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6, null, [[7, 14], [20, 27], [34, 39], [46, 68], [76, 82], [94, 100], [118, 123]]);
    }));

    return function setup() {
      return _ref7.apply(this, arguments);
    };
  }();

  var init = /*#__PURE__*/function () {
    var _ref8 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee7() {
      return runtime_1.wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              if (showModal) {
                _context7.next = 2;
                break;
              }

              return _context7.abrupt("return");

            case 2:
              stateReset();
              setup();

            case 4:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7);
    }));

    return function init() {
      return _ref8.apply(this, arguments);
    };
  }();

  React.useEffect(function () {
    init(); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [showModal]);

  var handleOptions = function handleOptions() {
    return React__default.createElement(Options, {
      state: screenState,
      onClose: handleClose,
      handleSetState: handleSetState,
      handleUserInfoButton: handleUserInfoButton
    });
  };

  var handleBack = function handleBack() {
    return React__default.createElement(BackButton, {
      isDisabled: !lastScreenState || [SCREEN_STATES.LOADING, SCREEN_STATES.STATUS].concat(Object.values(ERROR_STATES)).includes(lastScreenState) ? true : false,
      onClick: function onClick() {
        clearInterval(listener);
        handleScreen({
          state: lastScreenState
        });
      }
    });
  };

  var handleClose = function handleClose() {
    clearInterval(listener);
    setShowTimer(false);
    onClose();
  };

  var handleCloseButton = function handleCloseButton() {
    return React__default.createElement(CloseButton, {
      isDisabled: [SCREEN_STATES.LOADING, SCREEN_STATES.STATUS].includes(screenState) ? true : false,
      onClick: onClose
    });
  };

  var handleSetState = function handleSetState(screenState) {
    handleScreen({
      state: screenState
    });
    return;
  };

  var handleRecoveryButton = function handleRecoveryButton() {
    handleScreen({
      state: SCREEN_STATES.RECOVER
    });
    return;
  };

  var handleUserInfoButton = function handleUserInfoButton() {
    handleScreen({
      state: SCREEN_STATES.USER_INFO
    });
    return;
  };

  var handleRecover = /*#__PURE__*/function () {
    var _ref9 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee8(assetId, recipientAddress) {
      var _message12, _error;

      return runtime_1.wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              handleScreen({
                state: SCREEN_STATES.STATUS,
                title: "Recovering",
                message: "Recovering... This step can take some time if the chain is congested"
              });
              _context8.prev = 1;
              _context8.next = 4;
              return connextSdk.recover({
                assetId: assetId,
                recipientAddress: recipientAddress,
                onRecover: onSuccess
              });

            case 4:
              _context8.next = 14;
              break;

            case 6:
              _context8.prev = 6;
              _context8.t0 = _context8["catch"](1);
              _message12 = _context8.t0.message;
              console.log(_context8.t0, _message12);
              _error = _context8.t0;

              if (_context8.t0.message.includes("No balance found to recover")) {
                _error = new Error("No balance found to recover. This usually means either your tx or recovery already completed successfully.");
              }

              handleScreen({
                state: ERROR_STATES.ERROR_RECOVER,
                error: _error,
                message: _message12
              });
              return _context8.abrupt("return");

            case 14:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8, null, [[1, 6]]);
    }));

    return function handleRecover(_x4, _x5) {
      return _ref9.apply(this, arguments);
    };
  }();

  var switchNetwork = /*#__PURE__*/function () {
    var _ref10 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee9() {
      return runtime_1.wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              console.log(senderChain == null ? void 0 : senderChain.chainParams); // @ts-ignore

              _context9.next = 3;
              return ethereum.request({
                method: "wallet_addEthereumChain",
                params: [senderChain == null ? void 0 : senderChain.chainParams]
              });

            case 3:
              init();

            case 4:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9);
    }));

    return function switchNetwork() {
      return _ref10.apply(this, arguments);
    };
  }();

  var continueButton = /*#__PURE__*/function () {
    var _ref11 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee10() {
      var quote;
      return runtime_1.wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              setIsLoad(true);
              _context10.next = 3;
              return handleSwapCheck("0", false);

            case 3:
              quote = _context10.sent;
              console.log("continue", quote);

              if (quote) {
                _context10.next = 8;
                break;
              }

              handleScreen({
                state: ERROR_STATES.ERROR_TRANSFER,
                error: new Error("Error at estimateFees"),
                message: message
              });
              return _context10.abrupt("return");

            case 8:
              _context10.prev = 8;
              _context10.next = 11;
              return connextSdk.preTransferCheck(existingChannelBalanceUi);

            case 11:
              _context10.next = 18;
              break;

            case 13:
              _context10.prev = 13;
              _context10.t0 = _context10["catch"](8);
              console.log("Error at preCheck", _context10.t0);
              handleScreen({
                state: ERROR_STATES.ERROR_TRANSFER,
                error: _context10.t0,
                message: message
              });
              return _context10.abrupt("return");

            case 18:
              handleSwap(quote);
              setIsLoad(false);

            case 20:
            case "end":
              return _context10.stop();
          }
        }
      }, _callee10, null, [[8, 13]]);
    }));

    return function continueButton() {
      return _ref11.apply(this, arguments);
    };
  }();

  var addMoreFunds = /*#__PURE__*/function () {
    var _ref12 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee11() {
      return runtime_1.wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              // existing funds helper text will be added
              handleScreen({
                state: SCREEN_STATES.SWAP
              });

            case 1:
            case "end":
              return _context11.stop();
          }
        }
      }, _callee11);
    }));

    return function addMoreFunds() {
      return _ref12.apply(this, arguments);
    };
  }();

  var handleScreen = function handleScreen(params) {
    var _pError$context$valid, _pError$context;

    var state = params.state,
        pError = params.error,
        pTitle = params.title,
        pMessage = params.message;

    switch (state) {
      case SCREEN_STATES.LOADING:
        break;

      case SCREEN_STATES.EXISTING_BALANCE:
        break;

      case SCREEN_STATES.SWAP:
        break;

      case SCREEN_STATES.SUCCESS:
        break;

      case SCREEN_STATES.RECOVER:
        break;

      case SCREEN_STATES.LISTENER:
        break;

      case SCREEN_STATES.STATUS:
        setTitle(pTitle);
        setMessage(pMessage);
        break;

      case SCREEN_STATES.HISTORY:
        break;

      case SCREEN_STATES.USER_INFO:
        break;

      case SCREEN_STATES.RECOVER_SUCCESS:
        break;

      default:
        console.error("error pMessage: ", pMessage);

        var _title = pTitle ? pTitle : state === ERROR_STATES.ERROR_TRANSFER ? "Transfer Error" : "Setup Error";

        var _pError = (_pError$context$valid = (_pError$context = pError.context) == null ? void 0 : _pError$context.validationError) != null ? _pError$context$valid : pError;

        setTitle(_title);
        setError(_pError);
        break;
    }

    setScreenState(function (prevState) {
      setLastScreenState(prevState);
      return state;
    });
    return;
  };

  var activeScreen = function activeScreen(state) {
    switch (state) {
      case SCREEN_STATES.LOADING:
        return React__default.createElement(Loading, {
          message: message
        });

      case SCREEN_STATES.STATUS:
        return React__default.createElement(Status, {
          title: title,
          message: message,
          senderChainInfo: senderChain,
          receiverChainInfo: receiverChain,
          receiverAddress: withdrawalRecipient,
          showNetworkBar: lastScreenState === SCREEN_STATES.RECOVER ? false : true,
          options: handleOptions
        });

      case SCREEN_STATES.EXISTING_BALANCE:
        return React__default.createElement(ExistingBalance, {
          addMoreFunds: addMoreFunds,
          isLoad: isLoad,
          continueButton: continueButton,
          existingChannelBalance: existingChannelBalanceUi,
          senderChainInfo: senderChain,
          receiverChainInfo: receiverChain,
          receiverAddress: withdrawalRecipient,
          options: handleOptions
        });

      case SCREEN_STATES.SWAP:
        return React__default.createElement(Swap, {
          onUserInput: handleSwapCheck,
          swapRequest: handleSwapRequest,
          isLoad: isLoad,
          inputReadOnly: inputReadOnly,
          userAddress: userAddress,
          userBalance: userBalance,
          amountError: amountError,
          vaultName: vaultName,
          senderChainInfo: senderChain,
          receiverChainInfo: receiverChain,
          receiverAddress: withdrawalRecipient,
          senderAmount: transferAmountUi,
          recipientAmount: receivedAmountUi,
          existingChannelBalance: existingChannelBalanceUi,
          feeQuote: transferFeeUi,
          swapRate: swapRate,
          options: handleOptions
        });

      case SCREEN_STATES.HISTORY:
        return React__default.createElement(History, {
          options: handleOptions,
          connextSdk: connextSdk
        });

      case SCREEN_STATES.RECOVER:
        return React__default.createElement(Recover, {
          recover: handleRecover,
          handleOptions: handleOptions,
          handleBack: handleBack,
          userAddress: userAddress,
          tokenAddress: senderChain == null ? void 0 : senderChain.assetId
        });

      case SCREEN_STATES.RECOVER_SUCCESS:
        return React__default.createElement(RecoverSuccess, {
          amount: successWithdrawalAmount,
          transactionId: withdrawTx,
          senderChainInfo: senderChain,
          onClose: handleCloseButton,
          options: handleOptions
        });

      case SCREEN_STATES.ERROR_RECOVER:
        return React__default.createElement(RecoverError, {
          error: error != null ? error : new Error("unknown"),
          senderChannelAddress: connextSdk ? connextSdk.senderChainChannelAddress : "",
          recipientChannelAddress: connextSdk ? connextSdk.recipientChainChannelAddress : "",
          options: handleOptions,
          handleBack: handleBack,
          handleRecoveryButton: handleRecoveryButton
        });

      case SCREEN_STATES.LISTENER:
        return React__default.createElement(SwapListener, {
          showTimer: showTimer,
          senderChannelAddress: connextSdk.senderChainChannelAddress,
          senderChainInfo: senderChain,
          receiverChainInfo: receiverChain,
          receiverAddress: withdrawalRecipient,
          options: handleOptions,
          handleBack: handleBack
        });

      case SCREEN_STATES.USER_INFO:
        return React__default.createElement(UserInfo, {
          options: handleOptions,
          connextSdk: connextSdk
        });

      case SCREEN_STATES.SUCCESS:
        return React__default.createElement(Success, {
          amount: successWithdrawalAmount,
          rawWebProvider: _injectedProvider,
          transactionId: withdrawTx,
          senderChainInfo: senderChain,
          receiverChainInfo: receiverChain,
          receiverAddress: withdrawalRecipient,
          onClose: handleCloseButton,
          options: handleOptions
        });

      default:
        return React__default.createElement(Error$1, {
          error: error != null ? error : new Error("unknown"),
          title: title,
          retry: init,
          senderChannelAddress: connextSdk ? connextSdk.senderChainChannelAddress : "",
          recipientChannelAddress: connextSdk ? connextSdk.recipientChainChannelAddress : "",
          switchNetwork: switchNetwork,
          state: state,
          senderChainInfo: senderChain,
          receiverAddress: withdrawalRecipient,
          receiverChainInfo: receiverChain,
          handleRecoveryButton: handleRecoveryButton,
          options: handleOptions,
          handleBack: handleBack
        });
    }
  };

  return React__default.createElement(React__default.Fragment, null, React__default.createElement(styled.ThemeProvider, {
    theme: theme
  }, React__default.createElement(Fonts, null), React__default.createElement(Modal.ModalProvider, {
    backgroundComponent: FadingBackground
  }, React__default.createElement(StyledModal, {
    isOpen: showModal,
    allowScroll: true,
    // afterOpen={afterOpen}
    beforeClose: handleClose
  }, React__default.createElement(ModalOverlay, null), React__default.createElement(ModalContentContainer, null, activeScreen(screenState))))));
};
var StyledModal = /*#__PURE__*/Modal__default.styled(_templateObject$e || (_templateObject$e = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  background-color: white;\n  transition : all 0.3s ease-in-out;"])));
var FadingBackground = /*#__PURE__*/styled__default(Modal.BaseModalBackground)(_templateObject2$4 || (_templateObject2$4 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  transition: all 0.3s ease-in-out;\n"])));

exports.ConnextModal = ConnextModal;
//# sourceMappingURL=millenial-modal.cjs.development.js.map
